/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*----------------------------------------------------------------------------



File: _holddb.p



Description:

   This will return a parameter to the caller telling whether the database

   with the dictdb alias is a schemaholder db.  This needs to be a subprogram

   because the caller just changed the alias on the db.



Input/Output Parameters:

   

Author: Warren Bare



Date Created: 10/19/92



----------------------------------------------------------------------------*/



define output parameter p_holder as log.



p_holder = CAN-FIND(FIRST DICTDB._DB WHERE DICTDB._DB._DB-Type NE "Progress").

