/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/



/* edithelp.i */



/* 

   This file contains

   Help Context Identifiers for PROGRESS PROCEDURE EDITOR HELP

   embedded in PROGRESS pre-processor statements.

   

   The form used in this file is:



   	<Name of the Help Topic>

	&GLOBAL <context-string> <context-number>



*/



/* Help File for the Procedure Editor. */

&GLOBAL-DEFINE Help_File prohelp/editeng.hlp



/* Editor Help Contents screen. */

&GLOBAL Main_Index 49153



/* Editor Help Contents screen. */

&GLOBAL Menu_Commands 49154



/* Help for Main Editor window. */

&GLOBAL Procedure_Editor_Window 49155



/* Help for Editor Buffer List dialog box. */

&GLOBAL Buffer_List_Dialog_Box 49156



/* Help for Compiler Message dialog box. */

&GLOBAL Compiler_Message_Dialog_Box 49157



/* Help for Buffer Information dialog box. */

&GLOBAL Buffer_Settings_Dialog_Box 49158



/* Help for Editor Preferences dialog box. */

&GLOBAL System_Options_Dialog_Box 49159



/* Help for Save Buffers with Changes dialog box. */

&GLOBAL Save_Buffers_Dialog_Box 49160



/* How To Help topic (called from Help menu). */

&GLOBAL How_To 49161

