&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

&ANALYZE-RESUME

/* Connected Databases 

          sports           PROGRESS

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&Scoped-define FRAME-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: 



  Description: 



  Input Parameters:

      <none>



  Output Parameters:

      <none>



  Author: 



  Created: 

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */

DEFINE INPUT-OUTPUT PARAMETER v-item AS INTEGER                   NO-UNDO.



/* Local Variable Definitions ---                                       */

DEFINE VARIABLE item-row             AS ROWID                     NO-UNDO.

DEFINE VARIABLE ldummy               AS LOGICAL                   NO-UNDO.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE DIALOG-BOX



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME Dialog-Frame

&Scoped-define BROWSE-NAME item-brws



/* Internal Tables (found by Frame, Query & Browse Queries)             */

&Scoped-define INTERNAL-TABLES Item



/* Definitions for BROWSE item-brws                                     */

&Scoped-define FIELDS-IN-QUERY-item-brws Item.Item-num Item.Item-Name ~

Item.On-hand 

&Scoped-define ENABLED-FIELDS-IN-QUERY-item-brws 

&Scoped-define FIELD-PAIRS-IN-QUERY-item-brws

&Scoped-define OPEN-QUERY-item-brws OPEN QUERY item-brws FOR EACH Item NO-LOCK.

&Scoped-define TABLES-IN-QUERY-item-brws Item

&Scoped-define FIRST-TABLE-IN-QUERY-item-brws Item





/* Definitions for DIALOG-BOX Dialog-Frame                              */

&Scoped-define OPEN-BROWSERS-IN-QUERY-Dialog-Frame ~

    ~{&OPEN-QUERY-item-brws}



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS item-brws Btn_OK Btn_Cancel 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define a dialog box                                                  */



/* Definitions of the field level widgets                               */

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 

     LABEL "Cancel" 

     SIZE 15 BY 1.12

     BGCOLOR 8 .



DEFINE BUTTON Btn_OK AUTO-GO 

     LABEL "OK" 

     SIZE 15 BY 1.12

     BGCOLOR 8 .



/* Query definitions                                                    */

&ANALYZE-SUSPEND

DEFINE QUERY item-brws FOR 

      Item SCROLLING.

&ANALYZE-RESUME



/* Browse definitions                                                   */

DEFINE BROWSE item-brws

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS item-brws Dialog-Frame _STRUCTURED

  QUERY item-brws NO-LOCK DISPLAY

      Item.Item-num

      Item.Item-Name

      Item.On-hand

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME

    WITH NO-ROW-MARKERS SIZE 39 BY 10.86

         BGCOLOR 11 FGCOLOR 1 .





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME Dialog-Frame

     item-brws AT ROW 1.24 COL 2

     Btn_OK AT ROW 12.43 COL 4

     Btn_Cancel AT ROW 12.43 COL 24

     SPACE(2.79) SKIP(0.30)

    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 

         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 

         TITLE "Item Selection"

         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel.



 



/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: DIALOG-BOX

   Allow: Basic,Browse,DB-Fields,Query

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS





/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR DIALOG-BOX Dialog-Frame

   Default                                                              */

ASSIGN 

       FRAME Dialog-Frame:SCROLLABLE       = FALSE

       FRAME Dialog-Frame:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE item-brws

/* Query rebuild information for BROWSE item-brws

     _TblList          = "sports.Item"

     _Options          = "NO-LOCK"

     _FldNameList[1]   = sports.Item.Item-num

     _FldNameList[2]   = sports.Item.Item-Name

     _FldNameList[3]   = sports.Item.On-hand

     _Query            is OPENED

*/  /* BROWSE item-brws */

&ANALYZE-RESUME



 









/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame

ON WINDOW-CLOSE OF FRAME Dialog-Frame /* Item Selection */

DO:

  APPLY "END-ERROR":U TO SELF.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_Cancel

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel Dialog-Frame

ON CHOOSE OF Btn_Cancel IN FRAME Dialog-Frame /* Cancel */

DO:

  v-item = ?.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_OK

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK Dialog-Frame

ON CHOOSE OF Btn_OK IN FRAME Dialog-Frame /* OK */

DO:

  v-item = item.item-num.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define BROWSE-NAME item-brws

&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 





/* ***************************  Main Block  *************************** */



/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */

IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?

THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.





/* Now enable the interface and wait for the exit condition.            */

/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */

MAIN-BLOCK:

DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  RUN enable_UI.

  ldummy = item-brws:SET-REPOSITIONED-ROW(INTEGER(item-brws:DOWN / 2),"CONDITIONAL").

  FIND item WHERE item.item-num = v-item NO-LOCK NO-ERROR.

  IF AVAILABLE item THEN DO:

    item-row = ROWID(ITEM).

    REPOSITION item-brws TO ROWID(item-row).

  END.

  WAIT-FOR GO OF FRAME {&FRAME-NAME}.

END.

RUN disable_UI.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME Dialog-Frame.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  ENABLE item-brws Btn_OK Btn_Cancel 

      WITH FRAME Dialog-Frame.

  VIEW FRAME Dialog-Frame.

  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





