/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* row-end.i */

IF VALID-HANDLE (adm-object-hdl) THEN  /* If there's a Frame, etc. then */

    RUN dispatch IN THIS-PROCEDURE ('display-fields':U). /* display the fields*/

&IF DEFINED(adm-open-query) NE 0 &THEN      

  /* If there were external tables, then we check for different rows.

     If there is a KEY-NAME defined then always open the query. */

  IF key-name ne ? OR different-row

  THEN RUN dispatch IN THIS-PROCEDURE ('open-query':U).

  ELSE RUN notify IN THIS-PROCEDURE('row-available':U).

&ELSE              /* Note: open-query does its own notify of row-available */

RUN notify IN THIS-PROCEDURE ('row-available':U).

&ENDIF

