&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&Scoped-define FRAME-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 

/*------------------------------------------------------------------------



  File: 



  Description: 



  Input Parameters:

      <none>



  Output Parameters:

      <none>



  Author: 



  Created: 

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.       */

/*----------------------------------------------------------------------*/





/* ***************************  Definitions  ************************** */



{adeuib/uibhlp.i}          /* Help File Preprocessor Directives         */

/* Parameters Definitions ---                                           */

DEFINE INPUT-OUTPUT PARAMETER pcFileName   AS CHARACTER  NO-UNDO.

DEFINE INPUT-OUTPUT PARAMETER plFilePerRow AS LOGICAL    NO-UNDO.



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE Dialog-Box

&Scoped-define DB-AWARE no



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME Dialog-Frame



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS lFilePerRow fiFileName fiField Btn_OK ~

Btn_Cancel Btn_Help RECT-4 

&Scoped-Define DISPLAYED-OBJECTS lFilePerRow fiFileName fiField 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define a dialog box                                                  */



/* Definitions of the field level widgets                               */

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 

     LABEL "Cancel" 

     SIZE 15 BY 1.14

     BGCOLOR 8 .



DEFINE BUTTON Btn_Help 

     LABEL "&Help" 

     SIZE 15 BY 1.14

     BGCOLOR 8 .



DEFINE BUTTON Btn_OK AUTO-GO 

     LABEL "OK" 

     SIZE 15 BY 1.14

     BGCOLOR 8 .



DEFINE VARIABLE fiField AS CHARACTER FORMAT "X(30)":U 

     LABEL "Field to use" 

     VIEW-AS FILL-IN 

     SIZE 62.4 BY 1 NO-UNDO.



DEFINE VARIABLE fiFileName AS CHARACTER FORMAT "X(256)":U 

     LABEL "File name" 

     VIEW-AS FILL-IN 

     SIZE 62.4 BY 1 NO-UNDO.



DEFINE RECTANGLE RECT-4

     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 

     SIZE 77.6 BY 1.81.



DEFINE VARIABLE lFilePerRow AS LOGICAL INITIAL no 

     LABEL "File Per Record" 

     VIEW-AS TOGGLE-BOX

     SIZE 22.4 BY .81 NO-UNDO.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME Dialog-Frame

     lFilePerRow AT ROW 1.29 COL 15.8

     fiFileName AT ROW 2.52 COL 13.4 COLON-ALIGNED

     fiField AT ROW 3.76 COL 13.4 COLON-ALIGNED

     Btn_OK AT ROW 5.57 COL 2.6

     Btn_Cancel AT ROW 5.57 COL 18.2

     Btn_Help AT ROW 5.57 COL 62.6

     RECT-4 AT ROW 5.19 COL 1.4

     SPACE(0.19) SKIP(0.47)

    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 

         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 

         TITLE "Dataset Export Properties"

         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel.





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: Dialog-Box

   Allow: Basic,Browse,DB-Fields,Query

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS







/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR DIALOG-BOX Dialog-Frame

                                                                        */

ASSIGN 

       FRAME Dialog-Frame:SCROLLABLE       = FALSE

       FRAME Dialog-Frame:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 







/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame

ON WINDOW-CLOSE OF FRAME Dialog-Frame /* Dataset Export Properties */

DO:

  APPLY "END-ERROR":U TO SELF.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_Cancel

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel Dialog-Frame

ON CHOOSE OF Btn_Cancel IN FRAME Dialog-Frame /* Cancel */

DO:

  ASSIGN

    plFilePerRow = ?

    pcFileName = ?

    .

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_Help

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Help Dialog-Frame

ON CHOOSE OF Btn_Help IN FRAME Dialog-Frame /* Help */

OR HELP OF FRAME {&FRAME-NAME}

DO: 

  /* Help for this Frame */

  RUN adecomm/_adehelp.p

                ("ICADS":U, "CONTEXT":U, {&DataSet_Export_Properties_Dialog_Box}  , "":U).





END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_OK

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK Dialog-Frame

ON CHOOSE OF Btn_OK IN FRAME Dialog-Frame /* OK */

DO:

  ASSIGN

    plFilePerRow = lFilePerRow

    pcFileName = (IF lFilePerRow THEN fiField:SCREEN-VALUE ELSE fiFilename:SCREEN-VALUE)

    .

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME lFilePerRow

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL lFilePerRow Dialog-Frame

ON VALUE-CHANGED OF lFilePerRow IN FRAME Dialog-Frame /* File Per Record */

DO:

  RUN setSensitive.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 





/* ***************************  Main Block  *************************** */



/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */

IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?

THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.





/* Now enable the interface and wait for the exit condition.            */

/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */

MAIN-BLOCK:

DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  RUN enable_UI.

  RUN initializeProc.

  WAIT-FOR GO OF FRAME {&FRAME-NAME}.

END.

RUN disable_UI.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME Dialog-Frame.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  DISPLAY lFilePerRow fiFileName fiField 

      WITH FRAME Dialog-Frame.

  ENABLE lFilePerRow fiFileName fiField Btn_OK Btn_Cancel Btn_Help RECT-4 

      WITH FRAME Dialog-Frame.

  VIEW FRAME Dialog-Frame.

  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeProc Dialog-Frame 

PROCEDURE initializeProc :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  DO WITH FRAME {&FRAME-NAME}:

    IF plFilePerRow THEN

      ASSIGN

        fiFileName = "":U

        fiField = pcFileName.

    ELSE

      ASSIGN

        fiFileName = pcFileName

        fiField = "":U.

    lFilePerRow = plFilePerRow.

    DISPLAY

      lFilePerRow

      fiFileName

      fiField

      .

  END.



  RUN setSensitive.





END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setSensitive Dialog-Frame 

PROCEDURE setSensitive :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE VARIABLE cCurrVal AS CHARACTER  NO-UNDO.



  DO WITH FRAME {&FRAME-NAME}:



    IF INPUT lFilePerRow <> lFilePerRow THEN

    DO:

      ASSIGN

        lFilePerRow

        cCurrVal = (IF lFilePerRow THEN fiFileName:SCREEN-VALUE ELSE fiField:SCREEN-VALUE)

        fiFileName:SCREEN-VALUE = (IF lFilePerRow THEN "":U ELSE cCurrVal)

        fiField:SCREEN-VALUE = (IF NOT lFilePerRow THEN "":U ELSE cCurrVal)

      .

    END.



    fiFileName:SENSITIVE   = NOT lFilePerRow.

    fiField:SENSITIVE = lFilePerRow.

  END.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



