&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

/* Connected Databases 

          icfdb            PROGRESS

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" vTableWin _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" vTableWin _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* Temp-Table and Buffer definitions                                    */

DEFINE TEMP-TABLE RowObject

       {"af/obj2/gsmsefullo.i"}.





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS vTableWin 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: gsmseviewv.w



  Description:  Session Type SmartDataViewer



  Purpose:      Session Type Static SmartDataViewer



  Parameters:   <none>



  History:

  --------

  (v:010000)    Task:    90000026   UserRef:    posse

                Date:   12/04/2001  Author:     Tammy St Pierre



  Update Notes: Created from Template rysttviewv.w



---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       gsmseviewv.w

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    000000



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* Astra 2 object identifying preprocessor */

&glob   astra2-staticSmartDataViewer yes



{af/sup2/afglobals.i}



DEFINE VARIABLE gcSessionType AS CHARACTER  NO-UNDO.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDataViewer

&Scoped-define DB-AWARE no



&Scoped-define ADM-CONTAINER FRAME



&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Update-Source,TableIO-Target,GroupAssign-Source,GroupAssign-Target



/* Include file with RowObject temp-table definition */

&Scoped-define DATA-FIELD-DEFS "af/obj2/gsmsefullo.i"



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME frMain



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-FIELDS RowObject.session_type_code ~

RowObject.session_type_description RowObject.automatic_reconnect 

&Scoped-define ENABLED-TABLES RowObject

&Scoped-define FIRST-ENABLED-TABLE RowObject

&Scoped-Define ENABLED-OBJECTS fiOSLabel RECT-1 

&Scoped-Define DISPLAYED-FIELDS RowObject.session_type_code ~

RowObject.session_type_description RowObject.automatic_reconnect 

&Scoped-define DISPLAYED-TABLES RowObject

&Scoped-define FIRST-DISPLAYED-TABLE RowObject

&Scoped-Define DISPLAYED-OBJECTS fiOSLabel 



/* Custom List Definitions                                              */

/* ADM-ASSIGN-FIELDS,List-2,List-3,List-4,List-5,List-6                 */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME





/* ************************  Function Prototypes ********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getWindowHandle vTableWin 

FUNCTION getWindowHandle RETURNS HANDLE

  ( /* parameter-definitions */ )  FORWARD.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* ***********************  Control Definitions  ********************** */





/* Definitions of handles for SmartObjects                              */

DEFINE VARIABLE h_dynlookup AS HANDLE NO-UNDO.

DEFINE VARIABLE h_gsmsedtf1v AS HANDLE NO-UNDO.

DEFINE VARIABLE h_gsmsedtf2v AS HANDLE NO-UNDO.

DEFINE VARIABLE h_gsmsesdfv1 AS HANDLE NO-UNDO.



/* Definitions of the field level widgets                               */

DEFINE VARIABLE fiOSLabel AS CHARACTER FORMAT "X(256)":U INITIAL " Valid operating systems:" 

      VIEW-AS TEXT 

     SIZE 24 BY .62 NO-UNDO.



DEFINE RECTANGLE RECT-1

     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 

     SIZE 48.8 BY 5.29.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME frMain

     fiOSLabel AT ROW 5.33 COL 2.6 COLON-ALIGNED NO-LABEL

     RowObject.session_type_code AT ROW 1 COL 29.6 COLON-ALIGNED

          LABEL "Session type code"

          VIEW-AS FILL-IN 

          SIZE 45.2 BY 1

     RowObject.session_type_description AT ROW 3.1 COL 29.6 COLON-ALIGNED

          LABEL "Session type description"

          VIEW-AS FILL-IN 

          SIZE 45.4 BY 1

     RowObject.automatic_reconnect AT ROW 4.14 COL 31.6

          LABEL "Automatic reconnect"

          VIEW-AS TOGGLE-BOX

          SIZE 25.6 BY 1

     RECT-1 AT ROW 5.71 COL 3.4

     SPACE(38.40) SKIP(8.81)

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY USE-DICT-EXPS 

         SIDE-LABELS NO-UNDERLINE THREE-D NO-AUTO-VALIDATE 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDataViewer

   Data Source: "af/obj2/gsmsefullo.w"

   Allow: Basic,DB-Fields,Smart

   Container Links: Data-Target,Update-Source,TableIO-Target,GroupAssign-Source,GroupAssign-Target

   Frames: 1

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE

   Temp-Tables and Buffers:

      TABLE: RowObject D "?" ?  

      ADDITIONAL-FIELDS:

          {af/obj2/gsmsefullo.i}

      END-FIELDS.

   END-TABLES.

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW vTableWin ASSIGN

         HEIGHT             = 18.95

         WIDTH              = 90.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB vTableWin 

/* ************************* Included-Libraries *********************** */



{src/adm2/viewer.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW vTableWin

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME frMain

   NOT-VISIBLE Size-to-Fit Custom                                       */

ASSIGN 

       FRAME frMain:SCROLLABLE       = FALSE

       FRAME frMain:HIDDEN           = TRUE.



/* SETTINGS FOR TOGGLE-BOX RowObject.automatic_reconnect IN FRAME frMain

   EXP-LABEL                                                            */

/* SETTINGS FOR FILL-IN RowObject.session_type_code IN FRAME frMain

   EXP-LABEL                                                            */

/* SETTINGS FOR FILL-IN RowObject.session_type_description IN FRAME frMain

   EXP-LABEL                                                            */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME frMain

/* Query rebuild information for FRAME frMain

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME frMain */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK vTableWin 





/* ***************************  Main Block  *************************** */



  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

    RUN initializeObject.

  &ENDIF         



  /************************ INTERNAL PROCEDURES ********************/



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addRecord vTableWin 

PROCEDURE addRecord :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE VARIABLE cValue          AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE hDataSource     AS HANDLE       NO-UNDO.

  DEFINE VARIABLE hContainer      AS HANDLE       NO-UNDO.



  RUN SUPER.



  DO WITH FRAME {&FRAME-NAME}:

    ASSIGN

        hDataSource = {fn getDataSource}

        hContainer  = {fn getWindowHandle}

        cValue      = {fn getForeignValues hDataSource}

        cValue      = (IF DECIMAL(cValue) = ? OR DECIMAL(cValue) = 0.00 THEN {fnarg getUserProperty 'ParentKeyValue':U hContainer} ELSE cValue).



    IF DECIMAL(cValue) <> 0.00 AND

       DECIMAL(cValue) <> ?    THEN

      RUN assignNewValue IN h_dynlookup (cValue, "":U, TRUE).



    RUN setFieldSensitivity.

  END.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects vTableWin  _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/

  DEFINE VARIABLE currentPage  AS INTEGER NO-UNDO.



  ASSIGN currentPage = getCurrentPage().



  CASE currentPage: 



    WHEN 0 THEN DO:

       RUN constructObject (

             INPUT  'adm2/dynlookup.w':U ,

             INPUT  FRAME frMain:HANDLE ,

             INPUT  'DisplayedFieldgsm_session_type.session_type_codeKeyFieldgsm_session_type.session_type_objFieldLabelExtends session typeFieldTooltipPress F4 for LookupKeyFormat->>>>>>>>>>>>>>>>>9.999999999KeyDatatypedecimalDisplayFormatX(20)DisplayDatatypecharacterBaseQueryStringFOR EACH gsm_session_type BY gsm_session_type.session_type_codeQueryTablesgsm_session_typeBrowseFieldsgsm_session_type.session_type_code,gsm_session_type.session_type_descriptionBrowseFieldDataTypescharacter,characterBrowseFieldFormatsX(20)|X(35)RowsToBatch200BrowseTitleLookup Session TypesViewerLinkedFieldsLinkedFieldDataTypesLinkedFieldFormatsViewerLinkedWidgetsColumnLabelsColumnFormatSDFFileNameSDFTemplateLookupImageadeicon/select.bmpParentFieldParentFilterQueryMaintenanceObjectMaintenanceSDOCustomSuperProcPhysicalTableNamesTempTablesQueryBuilderJoinCodeQueryBuilderOptionListNO-LOCKQueryBuilderOrderListgsm_session_type.session_type_code^yesQueryBuilderTableOptionListNO-LOCKQueryBuilderTuneOptionsQueryBuilderWhereClausesPopupOnAmbiguousyesPopupOnUniqueAmbiguousnoPopupOnNotAvailnoBlankOnNotAvailnoMappedFieldsUseCacheyesSuperProcedureFieldNameextends_session_type_objDisplayFieldyesEnableFieldyesLocalFieldnoHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_dynlookup ).

       RUN repositionObject IN h_dynlookup ( 2.05 , 31.60 ) NO-ERROR.

       RUN resizeObject IN h_dynlookup ( 1.00 , 50.00 ) NO-ERROR.



       RUN constructObject (

             INPUT  'af/obj2/gsmsedtf2v.w':U ,

             INPUT  FRAME frMain:HANDLE ,

             INPUT  'FieldNamevalid_os_listDisplayFieldyesEnableFieldyesLocalFieldnoHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_gsmsedtf2v ).

       RUN repositionObject IN h_gsmsedtf2v ( 6.19 , 4.00 ) NO-ERROR.

       RUN resizeObject IN h_gsmsedtf2v ( 3.57 , 45.80 ) NO-ERROR.



       RUN constructObject (

             INPUT  'af/obj2/gsmsesdfv1.w':U ,

             INPUT  FRAME frMain:HANDLE ,

             INPUT  'FieldNameinactivity_timeout_periodDisplayFieldyesEnableFieldyesLocalFieldnoHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_gsmsesdfv1 ).

       RUN repositionObject IN h_gsmsesdfv1 ( 5.19 , 57.80 ) NO-ERROR.

       RUN resizeObject IN h_gsmsesdfv1 ( 5.81 , 30.40 ) NO-ERROR.



       RUN constructObject (

             INPUT  'af/obj2/gsmsedtf1v.w':U ,

             INPUT  FRAME frMain:HANDLE ,

             INPUT  'FieldNamephysical_session_listDisplayFieldyesEnableFieldyesLocalFieldnoHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_gsmsedtf1v ).

       RUN repositionObject IN h_gsmsedtf1v ( 11.24 , 2.60 ) NO-ERROR.

       RUN resizeObject IN h_gsmsedtf1v ( 8.57 , 88.00 ) NO-ERROR.



       /* Adjust the tab order of the smart objects. */

       RUN adjustTabOrder ( h_dynlookup ,

             RowObject.session_type_code:HANDLE IN FRAME frMain , 'AFTER':U ).

       RUN adjustTabOrder ( h_gsmsedtf2v ,

             RowObject.automatic_reconnect:HANDLE IN FRAME frMain , 'AFTER':U ).

       RUN adjustTabOrder ( h_gsmsesdfv1 ,

             h_gsmsedtf2v , 'AFTER':U ).

       RUN adjustTabOrder ( h_gsmsedtf1v ,

             h_gsmsesdfv1 , 'AFTER':U ).

    END. /* Page 0 */



  END CASE.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE cancelRecord vTableWin 

PROCEDURE cancelRecord :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */

  RUN setFieldSensitivity.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE copyRecord vTableWin 

PROCEDURE copyRecord :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */

  RUN setFieldSensitivity.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE dataAvailable vTableWin 

PROCEDURE dataAvailable :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE INPUT PARAMETER pcRelative AS CHARACTER NO-UNDO.



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER( INPUT pcRelative).



  /* Code placed here will execute AFTER standard behavior.    */

  gcSessionType = {fn getSavedScreenValue h_dynlookup}.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI vTableWin  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME frMain.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE resetRecord vTableWin 

PROCEDURE resetRecord :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */

  RUN setFieldSensitivity.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RTB_xref_generator vTableWin 

PROCEDURE RTB_xref_generator :

/* -----------------------------------------------------------

Purpose:    Generate RTB xrefs for SMARTOBJECTS.

Parameters: <none>

Notes:      This code is generated by the UIB.  DO NOT modify it.

            It is included for Roundtable Xref generation. Without

            it, Xrefs for SMARTOBJECTS could not be maintained by

            RTB.  It will in no way affect the operation of this

            program as it never gets executed.

-------------------------------------------------------------*/

  RUN "af\obj2\gsmsedtf1v.w *RTB-SmObj* ".

  RUN "af\obj2\gsmsedtf2v.w *RTB-SmObj* ".



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setFieldSensitivity vTableWin 

PROCEDURE setFieldSensitivity :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE VARIABLE cViewerMode   AS CHARACTER  NO-UNDO.



  DO WITH FRAME {&FRAME-NAME}:

    IF {fn getObjectMode} = "Modify":U THEN

      IF LOOKUP({fn getNewRecord}, "Add,Copy,Yes":U) <> 0 THEN

        cViewerMode = "Add":U.

      ELSE

        cViewerMode = "Modify":U.



    CASE cViewerMode:

      WHEN "Modify":U THEN

        RUN enableField IN h_dynlookup.



      WHEN "Add":U THEN

        RUN disableField IN h_dynlookup.

    END CASE.

  END.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateMode vTableWin 

PROCEDURE updateMode :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE INPUT PARAMETER pcMode AS CHARACTER NO-UNDO.



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER( INPUT pcMode).



  /* Code placed here will execute AFTER standard behavior.    */

  RUN setFieldSensitivity.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateRecord vTableWin 

PROCEDURE updateRecord :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */

  DEFINE VARIABLE cSessionType  AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE lNewRecord    AS LOGICAL    NO-UNDO.

  DEFINE VARIABLE hFilterViewer AS HANDLE     NO-UNDO.

  DEFINE VARIABLE hContainer    AS HANDLE     NO-UNDO.



  ASSIGN

      cSessionType = gcSessionType

      lNewRecord   = LOOKUP({fn getNewRecord}, "Add,Copy,Yes":U) <> 0.



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */

  IF RETURN-VALUE <> "":U THEN

    RETURN.



  RUN setFieldSensitivity.



  {get WindowHandle hContainer}.



  IF VALID-HANDLE(hContainer) THEN

    hFilterViewer = {fnarg linkHandles 'TreeFilter-Source':U hContainer}.



  IF NOT VALID-HANDLE(hFilterViewer) THEN

    RETURN.



  IF NOT lNewRecord AND cSessionType <> {fn getSavedScreenValue h_dynlookup} THEN

  DO:

    cSessionType = {fnarg widgetValue 'session_type_code':U}.



    {fnarg refreshTree "cSessionType, TRUE" hFilterViewer}.

  END.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



/* ************************  Function Implementations ***************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getWindowHandle vTableWin 

FUNCTION getWindowHandle RETURNS HANDLE

  ( /* parameter-definitions */ ) :

/*------------------------------------------------------------------------------

  Purpose:  

    Notes:  

------------------------------------------------------------------------------*/

  DEFINE VARIABLE hWindow AS HANDLE     NO-UNDO.



  {get ContainerSource hWindow}.



  DO WHILE VALID-HANDLE(hWindow) AND {fn getObjectType hWindow} <> "SmartWindow":U:

    {get ContainerSource hWindow hWindow}.

  END.



  RETURN hWindow.   /* Function return value. */



END FUNCTION.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



