&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&Scoped-define FRAME-NAME diDialog

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" diDialog _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" diDialog _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS diDialog 

/*---------------------------------------------------------------------------------

  File: gopenobjectpropd.w



  Description:  Open Object Property Dialog



  Purpose:



  Parameters:   <none>



  History:

  --------

  (v:010000)    Task:           0   UserRef:    

                Date:   06/17/2002  Author:     



  Update Notes: Created from Template rysttdilgd.w



---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       gobjectpropd.w

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    000000



/* Parameters Definitions ---                                           */

&IF DEFINED(UIB_is_Running) NE 0 &THEN

/* Local Variable Definitions ---       */

  DEFINE VARIABLE pcObject       AS CHARACTER NO-UNDO.

  DEFINE VARIABLE phSDO          AS HANDLE     NO-UNDO.



&ELSE

  DEFINE INPUT  PARAMETER pcObject       AS CHARACTER NO-UNDO.

  DEFINE INPUT  PARAMETER phSDO          AS HANDLE  NO-UNDO.



&ENDIF

/* Local Variable Definitions ---                                       */



/*  object identifying preprocessor */

&glob   astra2-staticSmartDialog yes



{src/adm2/globals.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDialog

&Scoped-define DB-AWARE no



&Scoped-define ADM-CONTAINER DIALOG-BOX



&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME diDialog



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define a dialog box                                                  */



/* Definitions of handles for SmartObjects                              */

DEFINE VARIABLE h_dyntoolbar AS HANDLE NO-UNDO.

DEFINE VARIABLE h_folder AS HANDLE NO-UNDO.

DEFINE VARIABLE h_gscobvi2tv AS HANDLE NO-UNDO.

DEFINE VARIABLE h_gscobvietv AS HANDLE NO-UNDO.



/* ************************  Frame Definitions  *********************** */



DEFINE FRAME diDialog

     SPACE(102.64) SKIP(20.18)

    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 

         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 

         TITLE "Object Properties".





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDialog

   Allow: Basic,Browse,DB-Fields,Query,Smart

   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

   Design Page: 1

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB diDialog 

/* ************************* Included-Libraries *********************** */



{src/adm2/containr.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR DIALOG-BOX diDialog

                                                                        */

ASSIGN 

       FRAME diDialog:SCROLLABLE       = FALSE

       FRAME diDialog:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX diDialog

/* Query rebuild information for DIALOG-BOX diDialog

     _Options          = "SHARE-LOCK"

     _Query            is NOT OPENED

*/  /* DIALOG-BOX diDialog */

&ANALYZE-RESUME



 







/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME diDialog

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL diDialog diDialog

ON WINDOW-CLOSE OF FRAME diDialog /* Object Properties */

DO:  

  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */

  APPLY "END-ERROR":U TO SELF.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK diDialog 





/* ***************************  Main Block  *************************** */



{src/adm2/dialogmn.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects diDialog  _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/

  DEFINE VARIABLE currentPage  AS INTEGER NO-UNDO.



  ASSIGN currentPage = getCurrentPage().



  CASE currentPage: 



    WHEN 0 THEN DO:

       RUN constructObject (

             INPUT  'adm2/dyntoolbar.w':U ,

             INPUT  FRAME diDialog:HANDLE ,

             INPUT  'FlatButtonsyesMenunoShowBorderyesToolbaryesActionGroupsTableio,NavigationSubModulesTableIOTypeSaveSupportedLinksNavigation-source,Tableio-sourceToolbarBandsToolbarParentMenuToolbarAutoSizenoToolbarDrawDirectionHorizontalToolbarInitialStateLogicalObjectNameDynToolbarAutoResizeDisabledActionsHiddenActionsUpdate,Txtok,Txtcancel,Txthelp,FilterHiddenToolbarBandsTransaction,Tableio,FolderfunctionHiddenMenuBandsMenuMergeOrder0EdgePixels2PanelTypeToolbarDeactivateTargetOnHidenoDisabledActionsNavigationTargetNameHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_dyntoolbar ).

       RUN repositionObject IN h_dyntoolbar ( 1.00 , 1.00 ) NO-ERROR.

       RUN resizeObject IN h_dyntoolbar ( 1.24 , 102.00 ) NO-ERROR.



       RUN constructObject (

             INPUT  'adm2/folder.w':U ,

             INPUT  FRAME diDialog:HANDLE ,

             INPUT  'FolderLabels':U + 'Details|More' + 'FolderTabWidth0FolderFont-1HideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_folder ).

       RUN repositionObject IN h_folder ( 2.91 , 1.00 ) NO-ERROR.

       RUN resizeObject IN h_folder ( 18.10 , 102.00 ) NO-ERROR.



       /* Links to SmartFolder h_folder. */

       RUN addLink ( h_folder , 'Page':U , THIS-PROCEDURE ).



       /* Adjust the tab order of the smart objects. */

       RUN adjustTabOrder ( h_folder ,

             h_dyntoolbar , 'AFTER':U ).

    END. /* Page 0 */

    WHEN 1 THEN DO:

       RUN constructObject (

             INPUT  'af/obj2/gscobvietv.w':U ,

             INPUT  FRAME diDialog:HANDLE ,

             INPUT  'EnabledObjFldsToDisable(All)DataSourceNamesUpdateTargetNamesLogicalObjectNameLogicalObjectNamePhysicalObjectNamegscobvietv.wDynamicObjectnoRunAttributeHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_gscobvietv ).

       RUN repositionObject IN h_gscobvietv ( 4.81 , 3.80 ) NO-ERROR.

       /* Size in AB:  ( 15.05 , 97.40 ) */



       /* Adjust the tab order of the smart objects. */

       RUN adjustTabOrder ( h_folder ,

             h_dyntoolbar , 'AFTER':U ).

       RUN adjustTabOrder ( h_gscobvietv ,

             h_folder , 'AFTER':U ).

    END. /* Page 1 */

    WHEN 2 THEN DO:

       RUN constructObject (

             INPUT  'af/obj2/gscobvi2tv.w':U ,

             INPUT  FRAME diDialog:HANDLE ,

             INPUT  'EnabledObjFldsToDisable(None)DataSourceNamesUpdateTargetNamesLogicalObjectNameLogicalObjectNamePhysicalObjectNamegscobvi2tv.wDynamicObjectnoRunAttributeHideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_gscobvi2tv ).

       RUN repositionObject IN h_gscobvi2tv ( 4.81 , 6.00 ) NO-ERROR.

       /* Size in AB:  ( 14.57 , 77.00 ) */



       /* Adjust the tab order of the smart objects. */

       RUN adjustTabOrder ( h_folder ,

             h_dyntoolbar , 'AFTER':U ).

       RUN adjustTabOrder ( h_gscobvi2tv ,

             h_folder , 'AFTER':U ).

    END. /* Page 2 */



  END CASE.

  /* Select a Startup page. */

  IF currentPage eq 0

  THEN RUN selectPage IN THIS-PROCEDURE ( 1 ).



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createObjects diDialog 

PROCEDURE createObjects :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE VARIABLE currentPage     AS INTEGER NO-UNDO.



  ASSIGN currentPage = getCurrentPage().

  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER.



  IF NOT VALID-HANDLE(phSDO) THEN

     RETURN.



  CASE currentPage: 

    WHEN 0 THEN 

       RUN addLink(h_dynToolbar,"Navigation":U, phSDO).

     WHEN 1 THEN

       RUN addLink (phSDO, "DATA":U,h_gscobvietv).

    WHEN 2 THEN

      RUN addLink (phSDO, "DATA":U,h_gscobvi2tv).

 END CASE.

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE dataAvailable diDialog 

PROCEDURE dataAvailable :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE INPUT PARAMETER pcRelative AS CHARACTER NO-UNDO.



  DEFINE VARIABLE cObject AS CHARACTER  NO-UNDO.

  

  IF CAN-DO("FIRST,REV,NEXT,LAST,REPOSITIONED":U,pcRelative) THEN

  DO:

    cObject = trim(DYNAMIC-FUNC("columnStringValue":U IN phSDO,"object_FileName":U)).

    ASSIGN FRAME {&FRAME-NAME}:TITLE = "Object Properties (" + cObject + ")".

  



  END.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI diDialog  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME diDialog.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI diDialog  _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  VIEW FRAME diDialog.

  {&OPEN-BROWSERS-IN-QUERY-diDialog}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject diDialog 

PROCEDURE initializeObject :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/

DEFINE VARIABLE hContainerFrame AS HANDLE     NO-UNDO.

DEFINE VARIABLE hWidget         AS HANDLE     NO-UNDO.



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */

 /* Make the button on the viewer disabled */

 IF VALID-HANDLE(h_gscobvietv) THEN

 DO:

   {get ContainerHandle hContainerFrame h_gscobvietv}.

    ASSIGN hWIdget = hContainerFrame:CURRENT-ITERATION.

           hWidget = hWidget:FIRST-CHILD

    NO-ERROR. 

    DO WHILE VALID-HANDLE(hWidget):

        IF hWidget:TYPE = "BUTTON":U THEN

           hWidget:SENSITIVE = FALSE.

        hWidget = hWidget:NEXT-SIBLING.

    END.

 END.



 ASSIGN FRAME {&FRAME-NAME}:TITLE =  FRAME {&FRAME-NAME}:TITLE + " (" + pcObject + ")".

 

 SUBSCRIBE TO 'dataAvailable':U IN phSDO.

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateState diDialog 

PROCEDURE updateState :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

DEFINE INPUT  PARAMETER cState AS CHARACTER  NO-UNDO.



MESSAGE cState VIEW-AS ALERT-BOX INFO BUTTONS OK.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



