&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS sObject 

/*------------------------------------------------------------------------



  File:        ryclcstatusv.w

               This object viewer has a editor box to display the status

               of client cache generation.

               

  Description: from SMART.W - Template for basic ADM2 SmartObject



  Author:      Sunil Belgaonkar

  Created:     08/15/2003



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */

/* ***************************  Definitions  ************************** */



&scop object-name       ryclientcachelogv.w

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    000000



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/*  object identifying preprocessor */

&glob   astra2-staticSmartObject yes

{src/adm2/globals.i}



DEFINE VARIABLE ghContainerSource AS HANDLE     NO-UNDO.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartObject

&Scoped-define DB-AWARE no



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* Standard List Definitions                                            */

&Scoped-Define DISPLAYED-OBJECTS edStatus 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME





/* ************************  Function Prototypes ********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD updateLog sObject 

FUNCTION updateLog RETURNS LOGICAL

  ( INPUT pcLine AS CHARACTER )  FORWARD.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */

DEFINE VARIABLE edStatus AS CHARACTER 

     CONTEXT-HELP-ID 0

     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL LARGE

     SIZE 112 BY 14.29

     FONT 5 NO-UNDO.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     edStatus AT ROW 1.48 COL 3 NO-LABEL

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartObject

   Allow: Basic

   Frames: 1

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW sObject ASSIGN

         HEIGHT             = 15.14

         WIDTH              = 116.2.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB sObject 

/* ************************* Included-Libraries *********************** */



{src/adm2/visual.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW sObject

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE Size-to-Fit                                              */

ASSIGN 

       FRAME F-Main:SCROLLABLE       = FALSE

       FRAME F-Main:HIDDEN           = TRUE.



/* SETTINGS FOR EDITOR edStatus IN FRAME F-Main

   NO-ENABLE                                                            */

ASSIGN 

       edStatus:AUTO-RESIZE IN FRAME F-Main      = TRUE

       edStatus:RETURN-INSERTED IN FRAME F-Main  = TRUE

       edStatus:READ-ONLY IN FRAME F-Main        = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK sObject 





/* ***************************  Main Block  *************************** */



/* If testing in the UIB, initialize the SmartObject. */  

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

  RUN initializeObject.

&ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI sObject  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE getLogEditorHandle sObject 

PROCEDURE getLogEditorHandle :

/*------------------------------------------------------------------------------

  Purpose:     This procedure returns the handle to the editor widget.

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE OUTPUT PARAMETER hEditor AS HANDLE     NO-UNDO.



  hEditor = edStatus:HANDLE IN FRAME {&FRAME-NAME}.

  RETURN.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject sObject 

PROCEDURE initializeObject :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */

  ENABLE ALL WITH FRAME F-main.

  SUBSCRIBE TO "getLogEditorHandle":U        IN ghContainerSource.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE linkStateHandler sObject 

PROCEDURE linkStateHandler :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE INPUT PARAMETER pcState  AS CHARACTER NO-UNDO.

  DEFINE INPUT PARAMETER phObject AS HANDLE NO-UNDO.

  DEFINE INPUT PARAMETER pcLink   AS CHARACTER NO-UNDO.



  /* Code placed here will execute PRIOR to standard behavior. */



  RUN SUPER( INPUT pcState, INPUT phObject, INPUT pcLink).



  /* Code placed here will execute AFTER standard behavior.    */



  /* Set the handle of the container source immediately upon making the link */

  IF pcLink = "ContainerSource":U AND pcState = "Add":U THEN

     ASSIGN ghContainerSource = phObject.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



/* ************************  Function Implementations ***************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION updateLog sObject 

FUNCTION updateLog RETURNS LOGICAL

  ( INPUT pcLine AS CHARACTER ) :

/*------------------------------------------------------------------------------

  Purpose:  

    Notes:  

------------------------------------------------------------------------------*/

  DO WITH FRAME {&FRAME-NAME}:

      /* We don't want the editor blowing any limits */

      IF LENGTH(edStatus:SCREEN-VALUE) > 30000 THEN

          ASSIGN edStatus:SCREEN-VALUE = "":U.



      IF edStatus:SCREEN-VALUE = "":U THEN

          ASSIGN edStatus:SCREEN-VALUE = pcLine.

      ELSE

          ASSIGN edStatus:SCREEN-VALUE = edStatus:SCREEN-VALUE + CHR(10) + pcLine.

      edStatus:MOVE-TO-EOF().

  END.



  RETURN TRUE.   /* Function return value. */



END FUNCTION.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



