&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

/* Procedure Description

" Static SmartBusinessObject Template with wizard.



Use this template to create a new  SmartBusinessObject. When completed, this object can be drawn onto any 'smart' container such as a SmartWindow, SmartDialog or SmartFrame. Non-smart objects, such as web objects, can also access a SmartBusinessObject by running it persistently and calling its methods."

*/

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

{adecomm/appserv.i}

DEFINE VARIABLE h_Astra                    AS HANDLE          NO-UNDO.

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" sbo _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR " Static SmartBusinessObject Wizard" sbo _INLINE

/* Actions: af/cod/aftemwizcw.w ? ? ? af/sup/afwizdeltp.p */

/*  Static SmartBusinessObject Wizard

Welcome to the  Static SmartBusinessObject Wizard! During the next few steps, the wizard will lead you through all the stages necessary to create this type of object. If you cancel the wizard at any time, then all your changes will be lost. Once the wizard is completed, it is possible to recall parts of the wizard using the LIST option from the section editor. Press Next to proceed.

af/cod/aftemwiziw.w,af/cod/aftemwizpw.w,af/cod/aftemwizew.w 

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" sbo _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS sbo 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: rysttasboo.w



  Description:  Template  SmartBusinessObject Template



  Purpose:      Template  SmartBusinessObject Template



  Parameters:   <none>



  History:

  --------

  (v:010000)    Task:        6180   UserRef:    

                Date:   28/06/2000  Author:     Anthony Swindells



  Update Notes: V9 Templates



--------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       rysttasboo.w

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    010000



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/*  object identifying preprocessor */

&glob   astra2-staticSmartBusinessObject yes



{src/adm2/globals.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartBusinessObject

&Scoped-define DB-AWARE yes



&Scoped-define ADM-CONTAINER VIRTUAL



&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Update-Target,Navigation-Target,Commit-Target





/* Db-Required definitions. */

&IF DEFINED(DB-REQUIRED) = 0 &THEN

    &GLOBAL-DEFINE DB-REQUIRED TRUE

&ENDIF

&GLOBAL-DEFINE DB-REQUIRED-START   &IF {&DB-REQUIRED} &THEN

&GLOBAL-DEFINE DB-REQUIRED-END     &ENDIF





/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* ************************  Frame Definitions  *********************** */





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartBusinessObject Template

   Allow: Smart

   Container Links: Data-Target,Data-Source,Update-Target,Navigation-Target,Commit-Target

   Frames: 0

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE APPSERVER DB-AWARE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW sbo ASSIGN

         HEIGHT             = 1.62

         WIDTH              = 46.6.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB sbo 

/* ************************* Included-Libraries *********************** */



{src/adm2/sbo.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW sbo

  VISIBLE,,RUN-PERSISTENT                                               */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME









&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK sbo 





/* ***************************  Main Block  *************************** */



  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

    RUN initializeObject.

  &ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI sbo  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



