&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12

&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE

/* Actions: af/cod/aftemwizcw.w ? ? ? ? */

/* MIP Update Version Notes Wizard

Check object version notes.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 

/*---------------------------------------------------------------------------------

  File: ryprofplipp.p



  Description:  



  Purpose:



  Parameters:   <none>



  History:

  --------

  (v:010000)    Task:           0   UserRef:    

                Date:   04/23/2003  Author:     



  Update Notes: Created from Template rytemplipp.p



---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/



/* ***************************  Definitions  ************************** */

/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       ryprofplipp.p

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    000000



/* Astra object identifying preprocessor */

&glob   AstraPlip    yes



DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.



ASSIGN cObjectName = "{&object-name}":U.



&scop   mip-notify-user-on-plip-close   NO



{adm2/globals.i}



DEFINE VARIABLE cNameList     AS CHARACTER  NO-UNDO.

DEFINE VARIABLE cValueList    AS CHARACTER  NO-UNDO.

DEFINE VARIABLE raRunOnServer AS LOGICAL    NO-UNDO.

DEFINE VARIABLE fiDescription AS CHARACTER  NO-UNDO.

DEFINE VARIABLE fiFileName    AS CHARACTER  NO-UNDO.

DEFINE VARIABLE fiDirectory   AS CHARACTER  NO-UNDO.

DEFINE VARIABLE fiTraceFilter AS CHARACTER  NO-UNDO.

DEFINE VARIABLE fiTracing     AS CHARACTER  NO-UNDO.

DEFINE VARIABLE toEnabled     AS LOGICAL    NO-UNDO.

DEFINE VARIABLE toListings    AS LOGICAL    NO-UNDO.

DEFINE VARIABLE toCoverage    AS LOGICAL    NO-UNDO.

DEFINE VARIABLE raProfiling   AS LOGICAL    NO-UNDO.

DEFINE VARIABLE hUIM          AS HANDLE     NO-UNDO.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE Procedure

&Scoped-define DB-AWARE no







/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: Procedure

   Allow: 

   Frames: 0

   Add Fields to: Neither

   Other Settings: CODE-ONLY

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW Procedure ASSIGN

         HEIGHT             = 15.38

         WIDTH              = 49.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 

/* ************************* Included-Libraries *********************** */



{src/adm/method/attribut.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 





/* ***************************  Main Block  ******************************* */



{ry/app/ryplipmain.i}



hUIM = DYNAMIC-FUNCTION("getManagerHandle":U, INPUT "UserInterfaceManager":U).



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&IF DEFINED(EXCLUDE-killPlip) = 0 &THEN



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip Procedure 

PROCEDURE killPlip :

/*------------------------------------------------------------------------------

  Purpose:     entry point to instantly kill the plip if it should get lost in memory

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



{ry/app/ryplipkill.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ENDIF



&IF DEFINED(EXCLUDE-objectDescription) = 0 &THEN



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE objectDescription Procedure 

PROCEDURE objectDescription :

/*------------------------------------------------------------------------------

  Purpose:     Pass out a description of the PLIP, used in Plip temp-table

  Parameters:  <none>

  Notes:       This should be changed manually for each plip

------------------------------------------------------------------------------*/



DEFINE OUTPUT PARAMETER cDescription AS CHARACTER NO-UNDO.



ASSIGN cDescription = "Dynamics Template PLIP".



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ENDIF



&IF DEFINED(EXCLUDE-plipSetup) = 0 &THEN



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup Procedure 

PROCEDURE plipSetup :

/*------------------------------------------------------------------------------

  Purpose:    Run by main-block of PLIP at startup of PLIP

  Parameters: <none>

  Notes:       

------------------------------------------------------------------------------*/



{ry/app/ryplipsetu.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ENDIF



&IF DEFINED(EXCLUDE-plipShutdown) = 0 &THEN



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown Procedure 

PROCEDURE plipShutdown :

/*------------------------------------------------------------------------------

  Purpose:     This procedure will be run just before the calling program 

               terminates

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



{ry/app/ryplipshut.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ENDIF



&IF DEFINED(EXCLUDE-refreshValues) = 0 &THEN



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refreshValues Procedure 

PROCEDURE refreshValues :

/*------------------------------------------------------------------------------

  Purpose:  

    Notes:  



------------------------------------------------------------------------------*/

  DEFINE VARIABLE cAction AS CHARACTER  NO-UNDO.



  raRunOnServer = FALSE.

  RUN getProfilerAttrs IN gshSessionManager (INPUT raRunOnServer,

                                            OUTPUT fiDescription,

                                            OUTPUT fiFileName,

                                            OUTPUT fiDirectory,

                                            OUTPUT fiTraceFilter,

                                            OUTPUT fiTracing,

                                            OUTPUT toEnabled,

                                            OUTPUT toListings,

                                            OUTPUT toCoverage,

                                            OUTPUT raProfiling).



  cAction = "wbo.displayValues|" 

          + fiDescription + "|"

          + fiFileName    + "|" 

          + fiDirectory   + "|"

          + fiTraceFilter + "|"

          + fiTracing     + "|"   

          + (IF toEnabled   THEN "true" ELSE "false") + "|"

          + (IF toListings  THEN "true" ELSE "false") + "|"

          + (IF toCoverage  THEN "true" ELSE "false") + "|"

          + (IF raProfiling THEN "true" ELSE "false").



  RUN setClientAction IN hUIM (cAction).

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ENDIF



