/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* t-a-dan.p - Danish language definitions for Admin module */



{ prores/t-define.i }



DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.



IF qbf-s < 0 THEN RETURN.

qbf-lang = "".



/*--------------------------------------------------------------------------*/

/*results.p,s-module.p*/

IF qbf-s = 1 THEN

  ASSIGN

    qbf-lang[ 1] = 'F. Foresprgsel'

    qbf-lang[ 2] = 'R. Rapporter'

    qbf-lang[ 3] = 'L. Labels'

    qbf-lang[ 4] = 'E. Exporter data'

    qbf-lang[ 5] = 'B. Bruger defineret'

    qbf-lang[ 6] = 'O. Opstning'

    qbf-lang[ 7] = 'A. Afslut'

    qbf-lang[ 8] = 'F. FAST TRACK'

    qbf-lang[10] = 'Filen' /*DBNAME.qc*/

    qbf-lang[11] = 'kunne ikke findes. Du m derfor initialisere'

	     + ' databasen. nsker du af gre dette nu ?'

    qbf-lang[12] = 'Vlg nyt modul eller tryk [' + KBLABEL("END-ERROR")

	     + '] for at blive i dette modul.'

    qbf-lang[13] = 'Du har ikke kbt RESULTS.  Programmet afsluttes.'

    qbf-lang[14] = 'Er du sikker p at du nsker at afslutte "~{1~}" nu?'

    qbf-lang[15] = 'MANUEL,SEMI,AUTO'

    qbf-lang[16] = 'Der er ingen databaser opkoblet.'

    qbf-lang[17] = 'Kan ikke afvikles nr en database har et logisk navn '

	     + 'begyndende med "QBF$".'

    qbf-lang[18] = 'Afslut'

    qbf-lang[19] = '** RESULTS er forvirret **^^I Katalog ~{1~}, '

	     + 'findes hverken ~{2~}.db eller ~{2~}.qc.  ~{3~}.qc '

	     + 'findes i PROPATH, men tilhre tilsyneladende '

	     + '~{3~}.db.  Du m ndre din PROPATH eller '

	     + 'flytte/slette ~{3~}.db og .qc.'

    /* 24,26,30,32 available if necessary */

    qbf-lang[21] = '         Der er tre mder at opbygge foresprgsels '

	     + 'moduler for'

    qbf-lang[22] = '         PROGRESS RESULTS p. Du kan altid efter '

	     + 'RESULTS opbygning'

    qbf-lang[23] = '         af modulerne, manuelt g ind og ndre dem'

    qbf-lang[25] = 'Du nsker manuelt at definere hver enkelt '

    qbf-lang[26] = 'foresprgsels modul.'

    qbf-lang[27] = 'Efter du har udvalgt et antal filer fra de opkoblede'

    qbf-lang[28] = 'databaser, generere RESULTS foresprgsels moduler'

    qbf-lang[29] = 'alene for de udvalgte filer.'

    qbf-lang[31] = 'RESULTS generere alle foresprgsels moduler automatisk.'.





/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/*a-user.p*/

IF qbf-s = 2 THEN

  /* format x(72) for 1,2,9-14,19-22 */

  ASSIGN

    qbf-lang[ 1] = 'Indtast navnet p den include fil der skal benyttes'

    qbf-lang[ 2] = 'til List funktionen i foresprgsels modulet.'

    qbf-lang[ 3] = '    Default Include Fil:' /*format x(24)*/



    qbf-lang[ 8] = 'Kan ikke finde program'



    qbf-lang[ 9] = 'Indtast navnet p opstarts programmet.  Dette program '

	     + 'kan vre enten'

    qbf-lang[10] = 'et simpelt logo, eller en komplet login procedure svarende '

	     + 'til "login.p"'

    qbf-lang[11] = 'i Katalog "DLC".  Programmet afvikles umiddelbart efter '

	     + 'lsningen'

    qbf-lang[12] = 'af linien "signon=" i filen DBNAME.qc.'

    qbf-lang[13] = 'Indtast produkt navnet, som du nsker det vist p'

    qbf-lang[14] = 'hoved menuen.'

    qbf-lang[15] = '       Opstarts Program:' /*format x(24)*/

    qbf-lang[16] = '           Produkt Navn:' /*format x(24)*/

    qbf-lang[17] = 'Defaults:'



    qbf-lang[18] = 'PROGRESS Bruger procedure:'

    qbf-lang[19] = 'Denne procedure afvikler nr "Bruger" optionen vlges '

	     + 'p alle menuer.'



    qbf-lang[20] = 'Dette tillader benyttelsen af et bruger-oprettet data '

	     + 'export program.'

    qbf-lang[21] = 'Indtast venligst bde procedure navnet og en beskrivelse'

    qbf-lang[22] = 'til brug p "Exporter Data - Opstning" menuen.'

    qbf-lang[23] = 'Procedure:'

    qbf-lang[24] = 'Beskrivelse:'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/*a-load.p:*/

IF qbf-s = 3 THEN

  ASSIGN

    /* menu strip for d-main.p,l-main.p,r-main.p */

    qbf-lang[ 1] = 'Hent,Ls en tidligere defineret ~{1~}.'

    qbf-lang[ 2] = 'Gem,Skriv den aktuelle ~{1~}.'

    qbf-lang[ 3] = 'Kr,Kr den aktuelle ~{1~}.'

    qbf-lang[ 4] = 'Definer,Udvlg filer og felter.'

    qbf-lang[ 5] = 'Opst, ndring af type, format eller layout af den '

		 + 'aktuelle ~{1~}.'

    qbf-lang[ 6] = 'Udvlg,Record udvlgelses editor.'

    qbf-lang[ 7] = 'Sorter,ndring af rkkeflgen af de valgte record.'

    qbf-lang[ 8] = 'Blank,Slet definitionen for den aktuelle ~{1~}.'

    qbf-lang[ 9] = 'Info,Information om den aktuelle opstning.'

    qbf-lang[10] = 'Modul,Skift til et andet modul.'

    qbf-lang[11] = 'Extern,Skift til det externe bruger definerede modul.'

    qbf-lang[12] = 'Afslut,Afslut.'

    qbf-lang[13] = '' /* terminator */

    qbf-lang[14] = 'export,label,rapport'



    qbf-lang[15] = 'Lser konfigurations filen...'



    /* system values for CONTINUE Must be <= 12 characters */

    qbf-lang[18] = '    Forst' /* for error dialog box */

    qbf-lang[19] = 'Dansk' /* this name of this language */

    /* word "of" for "xxx of yyy" on scrolling lists */

    qbf-lang[20] = 'af'

    /* standard product name */

    qbf-lang[22] = 'PROGRESS RESULTS'

    /* system values for descriptions of calc fields */

    qbf-lang[23] = ',Lbende Total,Procent af Total,Antal Funk,Streng Udtryk,'

	     + 'Dato Udtryk,Numerisk Udtryk,Logisk Udtryk,Stakket Array'

    /* system values for YES and NO.  Must be <= 8 characters each */

    qbf-lang[24] = '  Ja  ,  Nej  ' /* for yes/no dialog box */



    qbf-lang[25] = 'En automatisk opbygning blev afbrudt. Skal der forsttes '

	     + 'med den automatiske opbygning?'



    qbf-lang[26] = '* ADVARSEL - Versions konflikt *^^Aktuelle version '

	     + 'er  <~{1~}> mens .qc filen er for version <~{2~}>.  Der '

	     + 'kan opst problemer, indtil foresprgsels moduler er '

	     + 'genopbygget med "Applikations Genopbygning".'



    qbf-lang[27] = '* ADVARSEL - Manglende databaser *^^De(n) flgende '

	     + 'database(r) er krvet men er ikke opkoblet:'



    qbf-lang[32] = '* ADVARSEL - Definitions ndring *^^Database strukturen '

	     + 'er ndret siden nogle af foresprgslerne blev opbygget.  '

	     + 'Benyt "Applikation Genopbygning" fra Opstnings menuen '

	     + 's snart som muligt.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/* a-main.p */

IF qbf-s = 4 THEN

  ASSIGN

    qbf-lang[ 1] = " A. Applikations Genopbygning"

    qbf-lang[ 2] = " S. Skrm def for Foresprgsel"

    qbf-lang[ 3] = " R. Relationer mellem filer"



    qbf-lang[ 4] = " I. Indhold af Bruger Katalog"

    qbf-lang[ 5] = " H. Hvordan man Afslutter Appl"

    qbf-lang[ 6] = " M. Modul Rettigheder"

    qbf-lang[ 7] = " F. Foresprgsel Rettigheder"

    qbf-lang[ 8] = " O. Opstarts Program/Produkt"



    qbf-lang[11] = " V. Vlg Sprog"

    qbf-lang[12] = " P. Printer opstning"

    qbf-lang[13] = " T. Terminal Farve opstning"



    qbf-lang[14] = " L. Liste Program, Foresprgsel"

    qbf-lang[15] = " D. Default Rapport Opstning"

    qbf-lang[16] = " E. Brugerdefineret Export Format"

    qbf-lang[17] = " U. Label Felt Udvlgelse"

    qbf-lang[18] = " B. Bruger Funktion"



    qbf-lang[21] = 'Vlg et af punkterne, eller tryk [' + KBLABEL("END-ERROR")

	     + '] for at afslutte og gemme ndringer.'

    /* these next four have a length limit of 20 including colon */

    qbf-lang[22] = 'Filer:'

    qbf-lang[23] = 'Konfiguration:'

    qbf-lang[24] = 'Sikkerhed:'

    qbf-lang[25] = 'Moduler:'



    qbf-lang[26] = 'Opstning'

    qbf-lang[27] = 'Version'

    qbf-lang[28] = 'Lser yderligere opstninger fra '

	     + 'konfigurations filen.'

    qbf-lang[29] = 'Er du sikker p at du nsker at gendanne applikation?'

/* QUIT and RETURN are the PROGRESS keywords and cannot be translated */

    qbf-lang[30] = 'Nr brugeren forlader hovedmenuen, skal programmet s '

	     + 'udfre ''QUIT'' eller ''RETURN''?'

    qbf-lang[31] = 'Er du sikker p du nsker at forlade Opstnings '

	     + 'menuen nu?'

    qbf-lang[32] = 'Verificerer konfigurations filen, og gemmer alle '

	     + 'ndringer.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 5 THEN

  ASSIGN

/*a-perm.p, 1..7 also used by a-form.p and a-print.p*/

    qbf-lang[ 1] = 'Rettigheder'

    qbf-lang[ 2] = '    *                      - Alle brugere har adgang.'

    qbf-lang[ 3] = '    <bruger>,<bruger>,etc. - Kun disse brugeres har adgang.'

    qbf-lang[ 4] = '    !<bruger>,!<bruger>,*  - Alle undtagen disse brugers har '

	     + 'adgang.'

    qbf-lang[ 5] = '    acct*                  - Kun brugere der begynder med '

	     + '"acct" har adgang'

    qbf-lang[ 6] = 'Vis brugere efter deres login navn, og separer dem med'

	     + 'kommaer.'

    qbf-lang[ 7] = 'Bruger navne kan indeholde wildcards.  Benyt udrbstegn til '

	     + 'udelukkelse af brugere.'

	       /* from 8 thru 13, format x(30) */

    qbf-lang[ 8] = 'Vlg et modul fra listen'

    qbf-lang[ 9] = 'til venstre der skal'

    qbf-lang[10] = 'sttes restriktioner p.'

    qbf-lang[11] = 'Vlg en funktion fra listen'

    qbf-lang[12] = 'til venstre, der skal'

    qbf-lang[13] = 'sttes restriktioner p.'

    qbf-lang[14] = 'Tryk [' + KBLABEL("END-ERROR")

	     + '] nr ndringerne er foretaget.'

    qbf-lang[15] = 'Tryk [' + KBLABEL("GO") + '] for gem, ['

	     + KBLABEL("END-ERROR") + '] for at fortryde ndringer.'

    qbf-lang[16] = 'Du kan ikke udelukke dig selv fra system Opstning!'

/*a-print.p:*/     /*21 thru 26 must be format x(16) and right-justified */

    qbf-lang[21] = '  Initialisering'

    qbf-lang[22] = '                '

    qbf-lang[23] = '    Normal Print'

    qbf-lang[24] = '     Komprimeret'

    qbf-lang[25] = '  Fed skrift til'

    qbf-lang[26] = '  Fed skrift fra'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 6 THEN

  ASSIGN

/*a-write.p:*/

    qbf-lang[ 1] = 'Lser modul opstning'

    qbf-lang[ 2] = 'Lser farve opstning'

    qbf-lang[ 3] = 'Lser printer opstning'

    qbf-lang[ 4] = 'Lser liste af lsbare filer'

    qbf-lang[ 5] = 'Lser liste af relationer'

    qbf-lang[ 6] = 'Lser udvlgelses liste for adresse labels'

    qbf-lang[ 7] = 'Lser adgangs liste for foresprgsel funktioner'

    qbf-lang[ 8] = 'Lser bruger funktions informationer'

    qbf-lang[ 9] = 'Lser system rapport definitioner'



/* a-color.p*/

	     /* 12345678901234567890123456789012 */

    qbf-lang[11] = '  Angiv farve for terminal type:' /* must be 32 */

	     /* 1234567890123456789012345 */

    qbf-lang[12] = 'Menu:             Normal:' /* must be 25 */

    qbf-lang[13] = '                Markeret:'

    qbf-lang[14] = 'Dialog Ramme:     Normal:'

    qbf-lang[15] = '                Markeret:'

    qbf-lang[16] = 'Rulle liste:      Normal:'

    qbf-lang[17] = '                Markeret:'



/*a-felt.p*/    /*"----- ----- ----- ----- ----"*/

    qbf-lang[30] = 'Vis?  Opda?  Sg? List? Srt?'

    qbf-lang[31] = 'Skal vre i omrdet mellem 1 og 9999.'

    qbf-lang[32] = 'nsker du at gemme de ndringer du lige har foretaget til'

	     + 'felt listen?'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 8 THEN

/*a-label.p*/

  ASSIGN            /* 1..8 use format x(78) */

		/* 1 and 8 are available for more explanation, in */

		/*   case the translation won't fit in 2 thru 7.  */

    qbf-lang[ 2] = 'Indtast felt navnene der indeholder adresse information.  '

	     + 'Benytter CAN-DO'

    qbf-lang[ 3] = 'formatet til at sammenligne disse felt navne ("*" svarer '

	     + 'til et vilkrligt antal'

    qbf-lang[ 4] = 'karakterer, "." svarer til een vilkrlig karakter).  Denne '

	     + 'information benyttes'

    qbf-lang[ 5] = 'ved oprettelse af std. adresse labels.  Bemrk at nogle'

	     + 'informationer kan vre'

    qbf-lang[ 6] = 'redundante - for eksempel, hvis du altid gemmer post nummer'

	     + 'og by i'

    qbf-lang[ 7] = 'seperate felter, behver du ikke benytte "Nr-By" linien.'

	      /* each entry in list must be <= 5 characters long */

	      /* but may be any portion of address that is applicable */

	      /* in the target country */

    qbf-lang[ 9] = 'Pers,Titel,Firma,Adr1,Adr2,Adr3,Numm,By,Nr-By,Land'

    qbf-lang[10] = 'Felt indeholdende <Person navn>'

    qbf-lang[11] = 'Felt indeholdende <Titel>'

    qbf-lang[12] = 'Felt indeholdende <Firma navn>'

    qbf-lang[13] = 'Felt indeholdende <frste> linie af adressen (fx. vej)'

    qbf-lang[14] = 'Felt indeholdende <anden> linie af adressen (fx. PO Box)'

    qbf-lang[15] = 'Felt indeholdende <tredie> linie af adressen (valgfri)'

    qbf-lang[16] = 'Felt indeholdende <post nummer>'

    qbf-lang[17] = 'Felt indeholdende <post distrikt>'

    qbf-lang[18] = 'Felt indeholdende <kombineret post nr og distrikt>'

    qbf-lang[19] = 'Felt indeholdende <land>'



/*a-join.p*/

    qbf-lang[23] = 'Automatisk fil relatering er ikke tilladt.'

    qbf-lang[24] = 'Maximum antal af fil relationer er net.'

    qbf-lang[25] = 'Relation fra' /* 25 and 26 are automatically */

    qbf-lang[26] = 'til'          /*   right-justified           */

    qbf-lang[27] = 'Indtast WHERE eller OF betingelse: (blank angiver ingen relation)'

    qbf-lang[28] = 'Tryk [' + KBLABEL("END-ERROR") + '] nr opdateringen er udfrt.'

    qbf-lang[30] = 'Stningen skal begynde med WHERE eller OF.'

    qbf-lang[31] = 'Indtast frste file i relationen der skal indsttes/fjernes.'

    qbf-lang[32] = 'Indtast anden fil i relation.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/* a-form.p */

IF qbf-s = 9 THEN

  ASSIGN           /* 1..6 format x(45) */

    qbf-lang[ 1] = ' I. Indst ny Foresprgsel Skrm '

    qbf-lang[ 2] = ' V. Vlg Foresprgsel Skrm til editering '

    qbf-lang[ 3] = ' G. General Skrm karakteristik '

    qbf-lang[ 4] = ' F. Felter p Skrm '

    qbf-lang[ 5] = ' R. Rettigheder '

    qbf-lang[ 6] = ' S. Slet aktuelle Foresprgsel Skrm '

    qbf-lang[ 7] = ' Udvlg: ' /* format x(10) */

    qbf-lang[ 8] = ' Opdater: ' /* format x(10) */

	     /* cannot changed width of 9..16 from defined below */

    qbf-lang[ 9] = '      Database fil navn' /* right-justify 9..14 */

    qbf-lang[10] = '             Skrm type'

    qbf-lang[11] = 'Foresprg. program navn'

    qbf-lang[12] = 'Skrm''s fysisk fil navn'

    qbf-lang[13] = 'Frame navn for 4GL kode'

    qbf-lang[14] = '            Beskrivelse'

    qbf-lang[15] = '(.p forventet)   ' /* left-justify 15 and 16 */

    qbf-lang[16] = '(krver .navn)'

    qbf-lang[18] = 'Denne skrm er p ~{1~} linier.  Da RESULTS reserverer '

	     + 'fem linier til eget brug, vil dette billede ikke kunne vre '

	     + 'p en 24 liniers terminal.  Er du sikker p du nsker at '

	     + 'definere en skrm med denne strrelse?'

    qbf-lang[19] = 'Et foresprgsel program eksisterer allerede med dette navn.'

    qbf-lang[20] = 'Skrmen skal allerede findes, eller skal ende p .f for '

	     + 'automatisk generering.'

    qbf-lang[21] = 'Det navn du har valgt til 4GL skrmen er reserveret. '

	     + 'Vlg et andet.'

    qbf-lang[22] = ' Vlg lsbare Filer '

    qbf-lang[23] = 'Tryk [' + KBLABEL("END-ERROR") + '] nr opdateringen er udfrt'

    qbf-lang[24] = 'Gemmer skrm informationen i foresprgsel skrm cache...'

    qbf-lang[25] = 'Du har ndret mindst en foresprgsel skrm.  Du kan '

	     + 'enten kompilere den ndrede skrm nu, eller foretage'

	     + '"Applikation Genopbygning" senere.  Kompilering nu?'

    qbf-lang[26] = 'Ingen foresprgsel skrm med navnet "~{1~}" fundet. nsker '

	     + 'du at generere en?'

    qbf-lang[27] = 'En foresprgsel skrm kaldet "~{1~}" eksisterer. Benyt felter fra '

	     + 'denne skrm?'

    qbf-lang[28] = 'Er du sikker p at du nsker at slette foresprgsel skrm'

    qbf-lang[29] = '** Foresprgsel program "~{1~}" slettet. **'

    qbf-lang[30] = 'Udtrkker foresprgsel skrm...'

    qbf-lang[31] = 'Maximum antal af foresprgsel skrme er net.'

    qbf-lang[32] = 'Kan ikke opbygge foresprgsel skrm for denne fil.^^For at '

	     + 'bygge en foresprgsel skrm, krves enten at det benyttede '

	     + 'gateway supportere RECID, eller et unique index p filen.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/* a-print.p */

IF qbf-s = 10 THEN

  ASSIGN           /* 1..6 format x(45) */

    qbf-lang[ 1] = ' I. Indst nyt Udskrifts Enhed '

    qbf-lang[ 2] = ' V. Vlg Enhed der skal editeres '

    qbf-lang[ 3] = ' G. General Enheds karakteristik '

    qbf-lang[ 4] = ' K. Kontrol Sekvenser  '

    qbf-lang[ 5] = ' P. Printer Rettigheder '

    qbf-lang[ 6] = ' S. Slet aktuelle enhed '

    qbf-lang[ 7] = ' Udvlg: ' /* format x(10) */

    qbf-lang[ 8] = ' Opdater: ' /* format x(10) */

    qbf-lang[ 9] = 'Skal vre mindre end 256 men strre end 0'

    qbf-lang[10] = 'Type skal vre term, thru, to, view, file, page eller prog'

    qbf-lang[11] = 'Maximum antal udskrifts enheder er net.'

    qbf-lang[12] = 'Kun enheds type "term" kan skrive p terminalen.'

    qbf-lang[13] = 'Kan ikke det pgldende program navn i den aktuelle PROPATH.'

	      /*17 thru 20 must be format x(16) and right-justified */

    qbf-lang[17] = 'Beskiv for liste'

    qbf-lang[18] = '      Enhed navn'

    qbf-lang[19] = '   Maximum Brede'

    qbf-lang[20] = '            Type'

    qbf-lang[21] = 'se nedenfor'

    qbf-lang[22] = 'TERMINAL, som i OUTPUT TO TERMINAL PAGED'

    qbf-lang[23] = 'TO en enhed, som f.eks OUTPUT TO PRINTER'

    qbf-lang[24] = 'THROUGH et UNIX eller OS/2 spooler eller filter'

    qbf-lang[25] = 'Send rapporten til en fil, afvikl derefter program'

    qbf-lang[26] = 'Sprg brugeren om et filnavn for udskrifts destination'

    qbf-lang[27] = 'Til skrm med forrige-side, nste-side support'

    qbf-lang[28] = 'Kald et 4GL program til at starte/stoppe udskrift'

    qbf-lang[30] = 'Tryk [' + KBLABEL("END-ERROR") + '] nr opdateringen er udfrt'

    qbf-lang[31] = 'Der skal vre mindst een udskrifts enhed!'

    qbf-lang[32] = 'Er du sikker p at du nsker at slette denne printer?'.



/*--------------------------------------------------------------------------*/



RETURN.

