/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* t-a-fin.p - Finnish language definitions for Admin module */



{ prores/t-define.i }



DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.



IF qbf-s < 0 THEN RETURN.

qbf-lang = "".



/*--------------------------------------------------------------------------*/

/*results.p,s-module.p*/

IF qbf-s = 1 THEN

  ASSIGN

    qbf-lang[ 1] = 'K. Kyselyt'

    qbf-lang[ 2] = 'R. Raportit'

    qbf-lang[ 3] = 'T. Tarrat'

    qbf-lang[ 4] = 'S. Tiedon siirto'

    qbf-lang[ 5] = 'O. Omat'

    qbf-lang[ 6] = 'J. Jrj. hoito'

    qbf-lang[ 7] = 'X. Lopetus'

    qbf-lang[ 8] = 'F. FAST TRACK'

    qbf-lang[10] = 'Tiedostoa' /*DBNAME.qc*/

    qbf-lang[11] = 'ei lytynyt.  Tm edellytt tietokannan RESULTS-'

                 + 'mritysten uudelleen konfigurointia.  Teetk sen nyt?'

    qbf-lang[12] = 'Valitse uusi moduuli, [' + KBLABEL("END-ERROR")

                 + ']-nppimell pysyt tss moduulissa.'

    qbf-lang[13] = 'Et ole hankkinut RESULTS-tuotetta.  Ohjelma pttyi.'

    qbf-lang[14] = 'Haluatko varmasti lopettaa istunnon "~{1~}" nyt?'

    qbf-lang[15] = 'MANUAAL.,P-AUTOM.,AUTOM.'

    qbf-lang[16] = 'Yhtn tietokantaa ei ole kytketty istuntoon.'

    qbf-lang[17] = 'Toiminta ei onnistu tietokannalla, jonka looginen nimi '

                 + 'alkaa: "QBF$".'

    qbf-lang[18] = 'Lopetus'

    qbf-lang[19] = '** RESULTSilla tulkintavaikeuksia **^^Hakemistosta ~{1~} '

                 + 'ei lydy ~{2~}.db- eik ~{2~}.qc-tiedostoa.  ~{3~}.qc '

                 + 'lytyi PROPATH:sta, mutta se nytt kuuluvan '

                 + '~{3~}.db:hen.  Korjaa hakemistot PROPATH:ssa tai poista/'

                 + 'nime toiseksi ~{3~}.db ja .qc.'

    /* 24,26,30,32 available if necessary */

    qbf-lang[21] = '         Kyselylomakkeiden tekemiseen on kolme tapaa '

                 + 'PROGRESS'

    qbf-lang[22] = '         RESULTSissa.  Joka kerralla voit manuaalisesti '

                 + 'muokata'

    qbf-lang[23] = '         RESULTSin kyselylomakkeita.'

    qbf-lang[25] = 'Voit manuaalisesti mrt kunkin kyselylomakkeen.'

    qbf-lang[27] = 'Poimittuasi istuntoon kytketyist tietokannoista '

    qbf-lang[28] = 'haluamasi taulut, RESULTS tuottaa kyselylomakkeet '

    qbf-lang[29] = 'noille valituille tauluille.'

    qbf-lang[31] = 'RESULTS tuottaa kaikki kyselylomakkeet automaattisesti.'.





/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/*a-user.p*/

IF qbf-s = 2 THEN

  /* format x(72) for 1,2,9-14,19-22 */

  ASSIGN

    qbf-lang[ 1] = 'Anna liitetiedoston (include) nimi, jota kytetn'

    qbf-lang[ 2] = 'Kysely-moduulissa Selaa-valinnassa.'

    qbf-lang[ 3] = '   Oletus-liitetiedosto:' /*format x(24)*/



    qbf-lang[ 8] = 'Ohjelmaa ei lydy'



    qbf-lang[ 9] = 'Anna kirjoittautumisohjelman nimi.  Ohjelma voi olla '

                 + 'vaikka '

    qbf-lang[10] = 'yksinkertainen logo tai tydellinen "login.p":n korvaava'

                 + ' ohjelma.'

    qbf-lang[11] = 'Login.p on "DLC"-hakemistossa.  Ohjelma kynnistyy, kun '

                 + '"signon"'

    qbf-lang[12] = '"-rivi luetaan DBNAME.qc-tiedostosta.'

    qbf-lang[13] = 'Anna tuotteen nimi, jos haluat sellaisen tulostuvan '

    qbf-lang[14] = 'pvalikossa.'

    qbf-lang[15] = '    Sisnkirj. ohjelma:' /*format x(24)*/

    qbf-lang[16] = '          Tuotteen nimi:' /*format x(24)*/

    qbf-lang[17] = 'Oletukset:'



    qbf-lang[18] = 'Oma PROGRESS-ohjelma:'

    qbf-lang[19] = 'Tm ohjelma kynnistyy, kun "Omat"-vaihtoehto valitaan '

                 + 'jostain valikosta.'



    qbf-lang[20] = 'Tll otetaan kyttn itse tehty tiedonsiirto-ohjelma.'

    qbf-lang[21] = 'Syt sek ohjelman nimi ett sen kuvaus '

    qbf-lang[22] = '"Tiedon siirto - Muuta" valikossa.'

    qbf-lang[23] = 'Ohjelma:'

    qbf-lang[24] = 'Kuvaus:'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/*a-load.p:*/

IF qbf-s = 3 THEN

  ASSIGN

    /* menu strip for d-main.p,l-main.p,r-main.p */

    qbf-lang[ 1] = 'Hae,Otetaan esille aiemmin mritelty ~{1~}.'

    qbf-lang[ 2] = 'Tall,Talletetaan esill oleva ~{1~}mrittely.'

    qbf-lang[ 3] = 'Aja,Kynnistetn esill oleva ~{1~}ohjelma.'

    qbf-lang[ 4] = 'Valitse,Valitaan tarvittavat taulut ja kentt.'

    qbf-lang[ 5] = 'Muuta,Muutetaan esill olevan mrityksen muotoa, layout:ia yms.'

    qbf-lang[ 6] = 'Jossa,Tietueiden valintakriteerien (WHERE-lauseen) muokkaaminen.'

    qbf-lang[ 7] = 'Laj,Muutetaan tulostettavien tietueiden lajittelujrjestyst.'

    qbf-lang[ 8] = 'Poista,Poistetaan esill oleva tai muu mrittely.'

    qbf-lang[ 9] = 'Info,Nytetn tietoja esill olevasta mrityksest.'

    qbf-lang[10] = 'R-moduuli,Siirrytn toiseen RESULTSin moduuliin.'

    qbf-lang[11] = 'Omat,Siirrytn omiin valintoihin.'

    qbf-lang[12] = 'X=Paluu,Palataan ylemmlle valikkotasolle.'

    qbf-lang[13] = '' /* terminator */

    qbf-lang[14] = 'siirto,tarra,raportti'



    qbf-lang[15] = 'Asetuksia ladataan...'



    /* system values for CONTINUE Must be <= 12 characters */

    qbf-lang[18] = '     Jatka' /* for error dialog box */

    qbf-lang[19] = 'Finnish' /* this name of this language */

    /* word "of" for "xxx of yyy" on scrolling lists */

    qbf-lang[20] = '/'

    /* standard product name */

    qbf-lang[22] = 'PROGRESS RESULTS'

    /* system values for descriptions of calc fields */

    qbf-lang[23] = ',Kumulat.summa,Prosentteja,Lukumr,Teksti-lauseke,'

                 + 'Pvm-lauseke,Numeerinen,Looginen,Taulukko'

    /* system values for YES and NO.  Must be <= 8 characters each */

    qbf-lang[24] = ' Kyll ,  En  ' /* for yes/no dialog box */



    qbf-lang[25] = 'Automaattinen luonti oli kynniss ja keskeytyi.  '

                 + 'Kynnistetnk uudestaan?'



    qbf-lang[26] = '* VAROITUS - Versiot eivt tst *^^Nykyversio on '

                 + '<~{1~}> ja .qc-tiedoston versio on <~{2~}>.  Saattaa '

                 + 'tulla ongelmia siin vaiheessa, kun kyselylomakkeita '

                 + 'luodaan "Sovelluksen generoinnissa".'



    qbf-lang[27] = '* VAROITUS - Tietokannat puuttuvat *^^Seuraavat '

                 + 'tietokannat tarvittaisiin, muttei niihin ole yhteytt:'



    qbf-lang[32] = '* VAROITUS - Tietokantaa muutettu *^^Tietokannan rakennetta '

                 + 'on muutettu siit, kun viimeksi on tehty lomakkeita.  '

                 + 'Aja "Sovelluksen generointi" Jrjestelmn hoito-valikosta '

                 + 'mahdollisimman pian.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/* a-main.p */

IF qbf-s = 4 THEN

  ASSIGN

    qbf-lang[ 1] = " G. Sovelluksen generointi"

    qbf-lang[ 2] = " Q. Kyselylomakkeiden mritykset"

    qbf-lang[ 3] = " R. Taulujen vliset relaatiot"



    qbf-lang[ 4] = " H. Oman hakemiston sislt"

    qbf-lang[ 5] = " X. RESULTSin pttminen"

    qbf-lang[ 6] = " M. Moduulien kyttoikeudet"

    qbf-lang[ 7] = " O. Oikeudet kyselytoimintoihin"

    qbf-lang[ 8] = " L. Kirjoittautuminen / Tuote"



    qbf-lang[11] = " K. Kieli"

    qbf-lang[12] = " P. Tulostusten asetukset"

    qbf-lang[13] = " V. Ptevrien asetukset"



    qbf-lang[14] = " S. Kyselyjen selausohjelma"

    qbf-lang[15] = " D. Raporttien oletukset"

    qbf-lang[16] = " I. Itsemritelty siirtomuoto"

    qbf-lang[17] = " T. Tarrakenttien tunnistus"

    qbf-lang[18] = " O. Omat-valinta"



    qbf-lang[21] = 'Valitse muutettava valikosta, [' + KBLABEL("END-ERROR")

                 + ']:ll muutokset tallentuvat.'

    /* these next four have a length limit of 20 including colon */

    qbf-lang[22] = 'Taulut:'

    qbf-lang[23] = 'Konfigurointi:'

    qbf-lang[24] = 'Suojaukset:'

    qbf-lang[25] = 'Moduulit:'



    qbf-lang[26] = 'Jrjestelmn hoito'

    qbf-lang[27] = 'Versio'

    qbf-lang[28] = 'Asetuksia ladataan...'

    qbf-lang[29] = 'Haluatko varmasti luoda koko RESULTS-sovelluksen uudestaan?'

/* QUIT and RETURN are the PROGRESS keywords and cannot be translated */

    qbf-lang[30] = 'Kun kyttj poistuu pvalikosta, pitisik lopettaa '

                 + 'istunto (Quit) vai ohjelma (Return)?'

    qbf-lang[31] = 'Haluatko varmasti poistua Jrjestelmn hoito-moduulista '

                 + 'nyt?'

    qbf-lang[32] = 'Tutkitaan asetukset ja talletetaan '

                 + 'tehdyt muutokset.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 5 THEN

  ASSIGN

/*a-perm.p, 1..7 also used by a-form.p and a-print.p*/

    qbf-lang[ 1] = 'Kyttluvat'

    qbf-lang[ 2] = '    *                   - Kytt sallittu kaikille.'

    qbf-lang[ 3] = '    <user>,<user>,etc.  - Sallittu vain mainituille.'

    qbf-lang[ 4] = '    !<user>,!<user>,*   - Sallittu kaikille paitsi '

                 + 'mainituille'

    qbf-lang[ 5] = '    acct*               - Sallittu vain kyttjille, '

                 + 'jotka alkavat "acct"'

    qbf-lang[ 6] = 'Luettele kyttjt heidn tunnuksillaan; erotinmerkki '

                 + 'on pilkku.'

    qbf-lang[ 7] = 'Tunnuksissa thti (*) korvaa kaikki merkit, huutomerkill '

                 + 'kytt kielletn.'

                   /* from 8 thru 13, format x(30) */

    qbf-lang[ 8] = 'Valitse moduuli vasemmalla'

    qbf-lang[ 9] = 'olevasta luettelosta ja'

    qbf-lang[10] = 'aseta sille kyttluvat.'

    qbf-lang[11] = 'Valitse toiminto vasemmalla'

    qbf-lang[12] = 'olevasta luettelosta ja'

    qbf-lang[13] = 'aseta sille kyttluvat.'

    qbf-lang[14] = 'Paina [' + KBLABEL("END-ERROR")

                 + '] kun ptt muutosten teon.'

    qbf-lang[15] = 'Paina [' + KBLABEL("GO") + '] kun talletat, ['

                 + KBLABEL("END-ERROR") + '] kun perut muutokset.'

    qbf-lang[16] = 'Et voi kielt itseltsi Jrjestelmn hoitoa!'

/*a-print.p:*/     /*21 thru 26 must be format x(16) and right-justified */

    qbf-lang[21] = '      Alustukset'

    qbf-lang[22] = '                '

    qbf-lang[23] = 'Normaali tuloste'

    qbf-lang[24] = '     Tiivistetty'

    qbf-lang[25] = '       Paksunnos'

    qbf-lang[26] = '  Ei paksunnosta'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 6 THEN

  ASSIGN

/*a-write.p:*/

    qbf-lang[ 1] = 'Lataa moduulin asetuksia'

    qbf-lang[ 2] = 'Lataa vriasetuksia'

    qbf-lang[ 3] = 'Lataa tulostusasetuksia'

    qbf-lang[ 4] = 'Lataa katseltavien taulujen luetteloa'

    qbf-lang[ 5] = 'Lataa taulujen vlisten relaatioiden luetteloa'

    qbf-lang[ 6] = 'Lataa postitarroihin valittavien kenttien luetteloa'

    qbf-lang[ 7] = 'Lataa kyselytoimintojen kyttlupien luetteloaa'

    qbf-lang[ 8] = 'Lataa kyttjkohtaisia tietoja'

    qbf-lang[ 9] = 'Lataa raporttien oletustietoja'



/* a-color.p*/

                 /* 12345678901234567890123456789012 */

    qbf-lang[11] = '                    Ptetyyppi:' /* must be 32 */

                 /* 1234567890123456789012345 */

    qbf-lang[12] = 'Valikko:        Normaali:' /* must be 25 */

    qbf-lang[13] = '              Korostettu:'

    qbf-lang[14] = 'Kysymyslomake:  Normaali:'

    qbf-lang[15] = '              Korostettu:'

    qbf-lang[16] = 'Selauslista:    Normaali:'

    qbf-lang[17] = '              Korostettu:'



/*a-field.p*/    /*"----- ----- ----- ----- ----"*/

    qbf-lang[30] = 'Nyt?Muuta?Kysy? Selaa? Jr'

    qbf-lang[31] = 'Pit olla vlilt 1 -- 9999.'

    qbf-lang[32] = 'Haluatko tallettaa sken tekemsi muutokset '

                 + 'taulujen luetteloon?'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 8 THEN

/*a-label.p*/

  ASSIGN            /* 1..8 use format x(78) */

                    /* 1 and 8 are available for more explanation, in */

                    /*   case the translation won't fit in 2 thru 7.  */

    qbf-lang[ 2] = 'Syt kenttien nimet, joissa on osoitetiedot. '

                 + 'Kyt CAN-DO-muotoa.'

    qbf-lang[ 3] = '(Kenttnimiss "*" tarkoittaa vaihtelevaa mr '

                 + 'mit merkkej tahansa, '

    qbf-lang[ 4] = '"." tarkoittaa mit tahansa yht merkki).  Tt '

                 + 'tietoa kytetn'

    qbf-lang[ 5] = 'postitustarrojen oletustietoina.  Ota huomioon, '

                 + 'ett jotkut tiedot'

    qbf-lang[ 6] = 'voivat tulla kahdesti - esim. jos aina talletat postitoi'

                 + 'mipaikan '

    qbf-lang[ 7] = 'ja postinumeron eri kenttin, et tarvitse "Pt-Pn"-rivi.'

                  /* each entry in list must be <= 5 characters long */

                  /* but may be any portion of address that is applicable */

                  /* in the target country */

    qbf-lang[ 9] = 'Nimi,Oso-1,Oso-2,Oso-3,Posti,P-nro,Pt-Pn,Maa,Lis-1,Lis-2'

    qbf-lang[10] = 'Kentt jossa on vastaanottajan nimi'

    qbf-lang[11] = 'Osoitteen ensimmisen rivin kentt (esim. katuosoite)'

    qbf-lang[12] = 'Osoitteen toisen rivin kentt (esim. postilokero)'

    qbf-lang[13] = 'Osoitteen kolmas rivi (valinnainen, esim. jakoalue)'

    qbf-lang[14] = 'Postinumeron kentt '

    qbf-lang[15] = 'Postitoimipaikan kentt'

    qbf-lang[16] = 'Yhdistetty kentt: postinumero - postitoimipaikka'

    qbf-lang[17] = 'Kentt, jossa on vastaanottajan maa'

    qbf-lang[18] = 'Valinnainen liskentt'

    qbf-lang[19] = 'Valinnainen liskentt'



/*a-join.p*/

    qbf-lang[23] = 'Taulusta itseen-yhdisteit ei viel sallita.'

    qbf-lang[24] = 'Maksimi mr yhdisterelaatiota saavutettu.'

    qbf-lang[25] = 'Relaatio, mist' /* 25 and 26 are automatically */

    qbf-lang[26] = 'mihin'          /*   right-justified           */

    qbf-lang[27] = 'Syt WHERE tai OF-lause; tyhjksi jtt poistaa relaation)'

    qbf-lang[28] = 'Paina [' + KBLABEL("END-ERROR") + '] kun pivitys on valmis.'

    qbf-lang[30] = 'Lauseen pit alkaa WHERE- tai OF-sanalla.'

    qbf-lang[31] = 'Syt relaation ensimminen taulu listtvksi tai poistettavaksi.'

    qbf-lang[32] = 'Syt sitten relaation toinen taulu.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/* a-form.p */

IF qbf-s = 9 THEN

  ASSIGN           /* 1..6 format x(45) */

    qbf-lang[ 1] = ' U. Uusi kyselylomake'

    qbf-lang[ 2] = ' M. Muuta kyselylomaketta '

    qbf-lang[ 3] = ' Y. Yleispiirteit '

    qbf-lang[ 4] = ' T. Toimintojen kentti '

    qbf-lang[ 5] = ' K. Kyttlupia '

    qbf-lang[ 6] = ' P. Poista kyselylomake '

    qbf-lang[ 7] = '  Valitse:' /* format x(10) */

    qbf-lang[ 8] = '    Muuta:' /* format x(10) */

                 /* cannot changed width of 9..16 from defined below */

    qbf-lang[ 9] = '      Tietokannan taulu' /* right-justify 9..14 */

    qbf-lang[10] = '       Lomakkeen tyyppi'

    qbf-lang[11] = 'Kyselyohjelman tiedosto'

    qbf-lang[12] = ' Lomakkeen tiedostonimi'

    qbf-lang[13] = '  Ohjelmatiedoston nimi'

    qbf-lang[14] = '                 Kuvaus'

    qbf-lang[15] = '(.p oletettu)    ' /* left-justify 15 and 16 */

    qbf-lang[16] = '(p.o. jatko-osa) '

    qbf-lang[18] = 'Lomake on ~{1~} rivi pitk.  Koska RESULTS varaa '

                 + 'viisi rivi omaan kyttns, tm ylitt 24x80 merkin '

                 + 'kuvaruudun koon.  Haluatko varmasti mritell lomakkeen '

                 + 'koon nin suureksi?'

    qbf-lang[19] = 'Tmn niminen kyselyohjelma on jo olemassa.'

    qbf-lang[20] = 'Tmn lomakkeen pitisi jo olla olemassa tai nimen loppuun '

                 + 'tulee liitt .f, niin se tuotetaaan automaattisesti.'

    qbf-lang[21] = '4GL-lomakkeen nimeksi ei voi ottaa varattua sanaa.  '

                 + 'Valitse joku toinen.'

    qbf-lang[22] = ' Valitse tarvittavat taulut '

    qbf-lang[23] = 'Paina [' + KBLABEL("END-ERROR") + '] kun pivitys on valmis'

    qbf-lang[24] = 'Kyselylomakkeen tietoja tallennetaan...'

    qbf-lang[25] = 'Olet muuttanut vhintn yht kyselylomaketta.  Voit '

                 + 'joko knt muutetun lomakkeen nyt tai tehd '

                 + '"Sovelluksen generoinnin" myhemmin. Knnetnk nyt?'

    qbf-lang[26] = 'Kyselylomaketta "~{1~}" ei lydy.  Haluatko, ett '

                 + 'se luodaan?'

    qbf-lang[27] = 'Kyselylomake "~{1~}" on jo olemassa.  Kyt kentti tst '

                 + 'lomakkeesta?'

    qbf-lang[28] = 'Haluatko varmasti poistaa kyselylomakkeen'

    qbf-lang[29] = '** Kyselyohjelma "~{1~}" poistettu. **'

    qbf-lang[30] = 'Kirjoittaa kyselylomaketta...'

    qbf-lang[31] = 'Kyselylomakkeiden maksimimr on saavutettu.'

    qbf-lang[32] = 'Tlle taululle ei voi luoda kyselylomaketta.^^Kyselylomakkeen '

                 + 'muodostamiseksi tietokannan tytyy tukea tietueosoittimia '

                 + '(RECID) tai taululla pit olla yksiselitteinen indeksi.'.



/*--------------------------------------------------------------------------*/



ELSE



/*--------------------------------------------------------------------------*/

/* a-print.p */

IF qbf-s = 10 THEN

  ASSIGN           /* 1..6 format x(45) */

    qbf-lang[ 1] = ' U. Uusi tulostuslaite '

    qbf-lang[ 2] = ' M. Muuta tulostuslaitetta '

    qbf-lang[ 3] = ' Y. Laitteiden yleispiirteet '

    qbf-lang[ 4] = ' O. Kirjoittimien ohjausmerkit '

    qbf-lang[ 5] = ' K. Kirjoitinoikeudet '

    qbf-lang[ 6] = ' P. Poista tulostuslaite '

    qbf-lang[ 7] = '  Valitse:' /* format x(10) */

    qbf-lang[ 8] = '    Muuta:' /* format x(10) */

    qbf-lang[ 9] = 'Vhintn 256 mutta enemmn kuin 0'

    qbf-lang[10] = 'Tyypin pit olla term, thru, to, view, file, page tai prog'

    qbf-lang[11] = 'Tulostuslaitteiden maksimimr on saavutettu.'

    qbf-lang[12] = 'Vain "term"-laitetyyppi voi tulostaa ptteelle.'

    qbf-lang[13] = 'Ohjelman nime ei lydy PROPATH:n hakemistoista.'

                  /*17 thru 20 must be format x(16) and right-justified */

    qbf-lang[17] = 'Tulosteen kuvaus'

    qbf-lang[18] = '   Laitteen nimi'

    qbf-lang[19] = '   Maksimileveys'

    qbf-lang[20] = '          Tyyppi'

    qbf-lang[21] = 'katso alla'

    qbf-lang[22] = 'Ptteelle, kuten OUTPUT TO TERMINAL PAGED'

    qbf-lang[23] = 'Laitteeseen, kuten OUTPUT TO PRINTER'

    qbf-lang[24] = 'UNIX tai OS/2 prosessille (THROUGH)'

    qbf-lang[25] = 'Lhet tulostus tiedostoon, suorita sitten tm ohjelma'

    qbf-lang[26] = 'Kysy kyttjlt tulostuksen kohdetiedoston nimi'

    qbf-lang[27] = 'Kuvaruudulle sivuttain selattavaksi'

    qbf-lang[28] = 'Kutsu 4GL-ohjelmaa tulostusvirran avaamiseksi/sulkemiseksi'

    qbf-lang[30] = 'Paina [' + KBLABEL("END-ERROR") + '] kun pivitys on valmis'

    qbf-lang[31] = 'Vhintn yksi tulostuslaite pit olla!'

    qbf-lang[32] = 'Haluatko varmasti poistaa tmn tulostuslaitteen?'.



/*--------------------------------------------------------------------------*/



RETURN.

