/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* t-q-eng.p - English language definitions for Query module */



{ prores/t-define.i }



DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.



IF qbf-s < 0 THEN RETURN.

qbf-lang = "".



IF qbf-s = 1 THEN



  ASSIGN

    qbf-lang[ 1] = 'Aucun enregistrement n''a t trouv'

    qbf-lang[ 2] = 'Table complte,Jointure,Sous-ensemble'

    qbf-lang[ 3] = ' Tout , Dbut , Fin '

    qbf-lang[ 4] = 'Il n''y a pas d''index pour cette table.'

    qbf-lang[ 5] = 'Voulez-vous supprimer cet enregistrement ?'

    qbf-lang[ 6] = '' /* special total message: created from #7 or #8 */

    qbf-lang[ 7] = 'Opration total abandonne'

    qbf-lang[ 8] = 'Le nombre total d''enregistrements trouv est de '

    qbf-lang[ 9] = 'Total en cours... [' + KBLABEL("END-ERROR")

		 + '] pour arrter.'

    qbf-lang[10] = 'Egal ,Infrieur ,Inferieur ou gal ,'

		 + 'Plus grand que,Plus grand ou gal ,'

		 + 'Diffrent de,Correspond  ,Commence par'

    qbf-lang[11] = 'Il n''y a pas d''enregistrement disponible'

    qbf-lang[13] = 'Vous tes dj en dbut de fichier.'

    qbf-lang[14] = 'Vous tes dj en fin de fichier.'

    qbf-lang[15] = 'Il n''y a pas de forme dfinie pour cette requte.'

    qbf-lang[16] = 'Requte'

    qbf-lang[17] = 'Slectionner le nom de la requte  utiliser.'

    qbf-lang[18] = '[' + KBLABEL("GO")

		 + '] ou [' + KBLABEL("RETURN")

		 + '] pour slectionner ou [' + KBLABEL("END-ERROR")

		 + '] pour abandonner.'

    qbf-lang[19] = 'Chargement requte...'

    qbf-lang[20] = 'La requte compile manque  la procdure.  '

		 + 'The problme peut tre:^1) PROPATH erron,'

		 + '^2) fichier .r manquant ou '

		 + '^3) fichier .r non compil^(Vrifier le fichier '

		 + '<dbname>.ql pour les messages d''erreur).^^Vous '

		 + 'pouvez continuer, mais cela donnera un message d''erreur.  '

		 + 'Voulez-vous continuer?'

    qbf-lang[21] = 'il existe une clause WHERE pour la requte qui contient'

		 + 'des valeurs qui sont rsolules lors de l''exec. Ceci n''est'

		 + 'pas support dans le module requte. Ignorer la clause '

		 + 'WHERE et continuer?'

    qbf-lang[22] = '[' + KBLABEL("GET")

		 + '] pour slectionner les champs.'.



ELSE



IF qbf-s = 2 THEN

  ASSIGN

    qbf-lang[ 1] = 'Suivant,Enregistrement suivant.'

    qbf-lang[ 2] = 'Prc.,Enregistrement prcdent.'

    qbf-lang[ 3] = 'Dbut,Premier enregistrement.'

    qbf-lang[ 4] = 'Fin,Dernier enregistrement.'

    qbf-lang[ 5] = 'Ajoute,Ajouter un nouvel enregistrement.'

    qbf-lang[ 6] = 'M.a.j.,Mettre  jour l''enregistrement courant.'

    qbf-lang[ 7] = 'Copie,Copier l''enregistrement courant vers un nouveau.'

    qbf-lang[ 8] = 'Efface,Effacer l''enregistrement courant.'

    qbf-lang[ 9] = 'Autre,Passer  une autre requte.'

    qbf-lang[10] = 'Liste,Voir la liste des enregistrements.'

    qbf-lang[11] = 'Jointure,Joindre vers les enregistrements lis.'

    qbf-lang[12] = 'Requte,Requte par l''exemple d''enregistrements.'

    qbf-lang[13] = 'Condition,Condition de slection d''enregistrements'

    qbf-lang[14] = 'Total,Nombre d''enregistrements slectionns.'

    qbf-lang[15] = 'Ordre,Ordre de tri diffrent.'

    qbf-lang[16] = 'Module,Changement de module.'

    qbf-lang[17] = 'Info,Information sur les paramtres courants.'

    qbf-lang[18] = 'Utilisateur,Transfert vers un module utilisateur.'

    qbf-lang[19] = 'Quitter,Quitter.'

    qbf-lang[20] = ''. /* terminator */



RETURN.

