/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* ptlshlp.i */



/*

   This file contains

   Help Context Identifiers for PROGRESS PRO*Tools HELP

   embedded in PROGRESS pre-processor statements.



   The form used in this file is:



	   <Name of the Help Topic>

	   &Global-Define <context-string> <context-number>



   Please contact Documentation to make changes to this file. 

   Thanks. 

*/



/* PRO*Tools Help Contents screen */

&Global-define Main_Contents 0



/*How To help topic (called from Help menu) */

&GLOBAL-DEFINE How_To 40



/* PRO*Tools Palette */

&Global-define Protools_Palette 42



/* PRO*Tools Customization dialog box */

&Global-define Protools_Customize_Dlg_Box 12



/* Add Applet dialog box */

&Global-define Add_Applet_DB 31



/* Update Applet dialog box */

&Global-define Update_Applet_DB 32



/* Find Procedure to Run dialog box */

&Global-define Find_Procedure_DB 33



/* Database Connections Fields dialog box */

&Global-define DC_Fields_DB 30



/* PRO*Spy Contents */

&Global-define PRO_Spy_Contents 3



/* PRO*Spy Setting Breakpoints dialog box */

&Global-define PRO_Spy_Breakpoints 57



/* PRO*Spy Setting Filters dialog box */

&Global-define PRO_Spy_Filters 6



/* PRO*Spy Number of Messages dialog box */

&Global-define PRO_Spy_Number 7



/* PRO*Tools -- Color Changer */

&GLOBAL-DEFINE Color_Changer 14



/* PRO*Tools -- Configuration File */

&GLOBAL-DEFINE Configuration_File 15



/* PRO*Tools -- Control Hierarchy */

&GLOBAL-DEFINE Control_Hierarchy 16



/* PRO*Tools -- Database Connections */

&GLOBAL-DEFINE Database_Connections 17



/* PRO*Tools -- Procedure Object Viewer */

&GLOBAL-DEFINE Procedure_Object_Viewer 18



/* PRO*Tools -- PROPATH Editor */

&GLOBAL-DEFINE PROPATH_Editor 19



/* PRO*Tools -- Run Procedure */

&GLOBAL-DEFINE Run_Procedure 20



/* PRO*Tools -- Session Attributes */

&GLOBAL-DEFINE Session_Attributes 21



/* PRO*Tools -- Window Viewer */

&GLOBAL-DEFINE Window_Viewer 22



/* PRO*Tools --OS-Prompt*/

&GLOBAL-DEFINE OS_Prompt 36



/* PRO*Tools --OS-Prompt*/

&GLOBAL-DEFINE Font_Changer 37



/* PRO*Tools -- Screen Capture*/

&GLOBAL-DEFINE Screen_Capture 38



/* PRO*Tools -- Window Information*/

&GLOBAL-DEFINE Window_Information 39



/* PRO*Spy window */

&Global-define PRO_Spy_Window 4



/* New for version 8.1 ------------------------------------------------------ */



/* Smartobject Upgrade Utility */

&Global-define SmartObject_Upgrade_Utility 76



/* New for version 8.2A ----------------------------------------------------- */



/* Screen Scaling Utility */

&Global-define Screen_Scaling_Utility 99



/* New for version 9.0A ----------------------------------------------------- */



/* AppServer Partition Utility */

&GLOBAL-DEFINE AppServer_Partition 104



/* Prototype Generator */

&GLOBAL-DEFINE Protogen 105



/* Add Partition dialog of AppServer Partition Utility */

&GLOBAL-DEFINE Add_Partition_DB 106



/* SmartObject Upgrade Utility V9 */

&GLOBAL-DEFINE SmartObject_Upgrade_Utility_v9 5



/* AppServer Session Information PRO*Tool */

&GLOBAL-DEFINE AppServer_Session_Information 9



/* New for version 9.1B ----------------------------------------------------- */



/* Index value will change for 9.1B FCS */

&GLOBAL-DEFINE XML_Schema_Mapping_Tool 74



/* New for Dynamics 2.0 ----------------------------------------------------- */



/* Convert old Smart Objects to Dynamic Objects Utility */ 

&GLOBAL-DEFINE Static_to_Dynamic_Conversion_Utility 72 