&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

/* Connected Databases 

          ab               PROGRESS

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW



/* Temp-Table and Buffer definitions                                    */

DEFINE TEMP-TABLE RowObject

       {"adeuib/dabattribute.i"}.





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS vTableWin 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File:



  Description: from viewer.w - Template for SmartDataViewer objects



  Input Parameters:

      <none>



  Output Parameters:

      <none>



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDataViewer

&Scoped-define DB-AWARE no



&Scoped-define ADM-CONTAINER FRAME



&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Update-Source,TableIO-Target,GroupAssign-Source,GroupAssign-Target



/* Include file with RowObject temp-table definition */

&Scoped-define DATA-FIELD-DEFS "adeuib/dabattribute.i"



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-FIELDS RowObject.name RowObject.sq RowObject.descrip ~

RowObject.displaySeq RowObject.class RowObject.dataType RowObject.Adv ~

RowObject.custom RowObject.geom RowObject.multiLayout 

&Scoped-define ENABLED-TABLES RowObject

&Scoped-define FIRST-ENABLED-TABLE RowObject

&Scoped-define DISPLAYED-TABLES RowObject

&Scoped-define FIRST-DISPLAYED-TABLE RowObject

&Scoped-Define DISPLAYED-FIELDS RowObject.name RowObject.sq ~

RowObject.descrip RowObject.displaySeq RowObject.class RowObject.dataType ~

RowObject.Adv RowObject.custom RowObject.geom RowObject.multiLayout 



/* Custom List Definitions                                              */

/* ADM-ASSIGN-FIELDS,List-2,List-3,List-4,List-5,List-6                 */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */



/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     RowObject.name AT ROW 1.24 COL 16.2 COLON-ALIGNED

          LABEL "Attribute Name"

          VIEW-AS FILL-IN 

          SIZE 30 BY 1

     RowObject.sq AT ROW 1.24 COL 69.2 COLON-ALIGNED

          LABEL "Sequence"

          VIEW-AS FILL-IN 

          SIZE 6.2 BY 1

     RowObject.descrip AT ROW 2.38 COL 16.2 COLON-ALIGNED

          VIEW-AS FILL-IN 

          SIZE 30 BY 1

     RowObject.displaySeq AT ROW 2.38 COL 69.2 COLON-ALIGNED

          VIEW-AS FILL-IN 

          SIZE 6.2 BY 1

     RowObject.class AT ROW 3.76 COL 18 NO-LABEL

          VIEW-AS RADIO-SET VERTICAL

          RADIO-BUTTONS 

                    "Toggle", 1,

"Fill In", 2,

"Fill in:ATTR", 3,

"Combo Box", 4,

"Dialog", 5,

"Files...", 6,

"Editor", 7,

"List-Items", 8,

"Adv-Toggle", 9,

"Unknown", ?

          SIZE 26 BY 8.33

     RowObject.dataType AT ROW 3.76 COL 71 NO-LABEL

          VIEW-AS RADIO-SET VERTICAL

          RADIO-BUTTONS 

                    "Logical", "L":U,

"Integer", "I":U,

"Decimal", "D":U,

"Character", "C":U,

"Recid", "R":U

          SIZE 19 BY 4.76

     RowObject.Adv AT ROW 8.67 COL 71.2

          LABEL "Advanced"

          VIEW-AS TOGGLE-BOX

          SIZE 14 BY .81

     RowObject.custom AT ROW 9.48 COL 71.2

          LABEL "Can Set for Custom"

          VIEW-AS TOGGLE-BOX

          SIZE 23.8 BY .81

     RowObject.geom AT ROW 10.29 COL 71.2

          LABEL "Geometry"

          VIEW-AS TOGGLE-BOX

          SIZE 14 BY .81

     RowObject.multiLayout AT ROW 11.1 COL 71.2

          LABEL "Multiple Layout"

          VIEW-AS TOGGLE-BOX

          SIZE 22.8 BY .81

     "Class:" VIEW-AS TEXT

          SIZE 6 BY 1.19 AT ROW 3.52 COL 11.6

     "DataType:" VIEW-AS TEXT

          SIZE 10.6 BY 1.19 AT ROW 3.52 COL 60.2

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY USE-DICT-EXPS 

         SIDE-LABELS NO-UNDERLINE THREE-D NO-AUTO-VALIDATE 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDataViewer

   Data Source: "adeuib/dabattribute.w"

   Allow: Basic,DB-Fields,Smart

   Container Links: Data-Target,Update-Source,TableIO-Target,GroupAssign-Source,GroupAssign-Target

   Frames: 1

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE

   Temp-Tables and Buffers:

      TABLE: RowObject D "?" ?  

      ADDITIONAL-FIELDS:

          {adeuib/dabattribute.i}

      END-FIELDS.

   END-TABLES.

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW vTableWin ASSIGN

         HEIGHT             = 11.38

         WIDTH              = 96.8.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB vTableWin 

/* ************************* Included-Libraries *********************** */



{src/adm2/viewer.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW vTableWin

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE Size-to-Fit                                              */

ASSIGN 

       FRAME F-Main:SCROLLABLE       = FALSE

       FRAME F-Main:HIDDEN           = TRUE.



/* SETTINGS FOR TOGGLE-BOX RowObject.Adv IN FRAME F-Main

   EXP-LABEL                                                            */

/* SETTINGS FOR TOGGLE-BOX RowObject.custom IN FRAME F-Main

   EXP-LABEL                                                            */

/* SETTINGS FOR TOGGLE-BOX RowObject.geom IN FRAME F-Main

   EXP-LABEL                                                            */

/* SETTINGS FOR TOGGLE-BOX RowObject.multiLayout IN FRAME F-Main

   EXP-LABEL                                                            */

/* SETTINGS FOR FILL-IN RowObject.name IN FRAME F-Main

   EXP-LABEL                                                            */

/* SETTINGS FOR FILL-IN RowObject.sq IN FRAME F-Main

   EXP-LABEL                                                            */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK vTableWin 





/* ***************************  Main Block  *************************** */



  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

    RUN initializeObject.

  &ENDIF         

  

  /************************ INTERNAL PROCEDURES ********************/



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI vTableWin  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



