&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

&ANALYZE-RESUME

/* Connected Databases 

          sports           PROGRESS

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS B-table-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File:  



  Description: from BROWSER.W - Basic SmartBrowser Object Template



  Input Parameters:

      <none>



  Output Parameters:

      <none>



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartBrowser



&Scoped-define ADM-SUPPORTED-LINKS Record-Source,Record-Target,TableIO-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main

&Scoped-define BROWSE-NAME br_table



/* Internal Tables (found by Frame, Query & Browse Queries)             */

&Scoped-define INTERNAL-TABLES Customer



/* Definitions for BROWSE br_table                                      */

&Scoped-define FIELDS-IN-QUERY-br_table Customer.Name Customer.City ~

Customer.State Customer.Country 

&Scoped-define ENABLED-FIELDS-IN-QUERY-br_table 

&Scoped-define FIELD-PAIRS-IN-QUERY-br_table

&Scoped-define OPEN-QUERY-br_table OPEN QUERY br_table FOR EACH Customer NO-LOCK ~

    BY Customer.Name.

&Scoped-define TABLES-IN-QUERY-br_table Customer

&Scoped-define FIRST-TABLE-IN-QUERY-br_table Customer





/* Definitions for FRAME F-Main                                         */



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS br_table FILL-IN_Name 

&Scoped-Define DISPLAYED-OBJECTS FILL-IN_Name 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */

DEFINE VARIABLE FILL-IN_Name AS CHARACTER FORMAT "X(20)" 

     LABEL "Search On Customer Name" 

     VIEW-AS FILL-IN 

     SIZE 35 BY 1.24

     BGCOLOR 11 FGCOLOR 1 .



/* Query definitions                                                    */

&ANALYZE-SUSPEND

DEFINE QUERY br_table FOR 

      Customer SCROLLING.

&ANALYZE-RESUME



/* Browse definitions                                                   */

DEFINE BROWSE br_table

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS br_table B-table-Win _STRUCTURED

  QUERY br_table NO-LOCK DISPLAY

      Customer.Name

      Customer.City

      Customer.State

      Customer.Country

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME

    WITH NO-ASSIGN SEPARATORS SIZE 79.6 BY 4.29

         BGCOLOR 11 FGCOLOR 1 .





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     br_table AT ROW 1 COL 1

     FILL-IN_Name AT ROW 5.52 COL 3

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1 SCROLLABLE 

         BGCOLOR 8 FGCOLOR 0 .



 



/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartBrowser

   Allow: Basic,Browse

   Frames: 1

   Add Fields to: EXTERNAL-TABLES

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT."

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW B-table-Win ASSIGN

         HEIGHT             = 5.86

         WIDTH              = 80.

                                                                        */

&ANALYZE-RESUME





/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW B-table-Win

  NOT-VISIBLE,,RUN-PERSISTENT                                           */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE Size-to-Fit Default                                      */

ASSIGN 

       FRAME F-Main:SCROLLABLE       = FALSE

       FRAME F-Main:HIDDEN           = TRUE.



/* SETTINGS FOR FILL-IN FILL-IN_Name IN FRAME F-Main

   ALIGN-L                                                              */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE br_table

/* Query rebuild information for BROWSE br_table

     _TblList          = "sports.Customer"

     _Options          = "NO-LOCK"

     _OrdList          = "sports.Customer.Name|yes"

     _FldNameList[1]   = sports.Customer.Name

     _FldNameList[2]   = sports.Customer.City

     _FldNameList[3]   = sports.Customer.State

     _FldNameList[4]   = sports.Customer.Country

     _Query            is NOT OPENED

*/  /* BROWSE br_table */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB B-table-Win 

/* ************************* Included-Libraries *********************** */



{src/adm/method/browser.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ************************  Control Triggers  ************************ */



&Scoped-define BROWSE-NAME br_table

&Scoped-define SELF-NAME br_table

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table B-table-Win

ON ROW-ENTRY OF br_table IN FRAME F-Main

DO:

  /* This code displays initial values for newly added or copied rows. */

  {src/adm/template/brsentry.i}  

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table B-table-Win

ON ROW-LEAVE OF br_table IN FRAME F-Main

DO:

    /* Do not disable this code or no updates will take place except

     by pressing the Save button on an Update SmartPanel. */

   {src/adm/template/brsleave.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table B-table-Win

ON VALUE-CHANGED OF br_table IN FRAME F-Main

DO:

  /* This ADM trigger code must be preserved in order to notify other

     objects when the browser's current row changes. */

  {src/adm/template/brschnge.i}

  RUN new-state('on-top').

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME FILL-IN_Name

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL FILL-IN_Name B-table-Win

ON LEAVE OF FILL-IN_Name IN FRAME F-Main /* Search On Customer Name */

OR RETURN OF FILL-IN_name DO:

  IF SELF:SCREEN-VALUE NE "":U THEN DO:

    FIND FIRST customer WHERE customer.name >= SELF:SCREEN-VALUE

         NO-LOCK NO-ERROR.

    IF NOT AVAILABLE customer THEN

      FIND LAST customer USE-INDEX name NO-LOCK NO-ERROR.

    IF AVAILABLE customer THEN DO:

      REPOSITION {&BROWSE-NAME} TO ROWID ROWID(customer).

      RUN dispatch IN THIS-PROCEDURE ('row-changed').

    END.

    SELF:SCREEN-VALUE = "":U.

  END.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK B-table-Win 





/* ***************************  Main Block  *************************** */



&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

RUN dispatch IN THIS-PROCEDURE ('initialize').        

&ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-row-available B-table-Win _ADM-ROW-AVAILABLE

PROCEDURE adm-row-available :

/*------------------------------------------------------------------------------

  Purpose:     Dispatched to this procedure when the Record-

               Source has a new row available.  This procedure

               tries to get the new row (or foriegn keys) from

               the Record-Source and process it.

  Parameters:  <none>

------------------------------------------------------------------------------*/



  /* Define variables needed by this internal procedure.             */

  {src/adm/template/row-head.i}



  /* Process the newly available records (i.e. display fields,

     open queries, and/or pass records on to any RECORD-TARGETS).    */

  {src/adm/template/row-end.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI B-table-Win _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE send-records B-table-Win _ADM-SEND-RECORDS

PROCEDURE send-records :

/*------------------------------------------------------------------------------

  Purpose:     Send record ROWID's for all tables used by

               this file.

  Parameters:  see template/snd-head.i

------------------------------------------------------------------------------*/



  /* Define variables needed by this internal procedure.               */

  {src/adm/template/snd-head.i}



  /* For each requested table, put it's ROWID in the output list.      */

  {src/adm/template/snd-list.i "Customer"}



  /* Deal with any unexpected table requests before closing.           */

  {src/adm/template/snd-end.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE state-changed B-table-Win 

PROCEDURE state-changed :

/* -----------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

-------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p-issuer-hdl AS HANDLE    NO-UNDO.

  DEFINE INPUT PARAMETER p-state      AS CHARACTER NO-UNDO.



  CASE p-state:

      /* Object instance CASEs can go here to replace standard behavior

         or add new cases. */

      {src/adm/template/bstates.i}

  END CASE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





