/*********************************************************************


* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *


* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *


* below.  All Rights Reserved.                                       *


*                                                                    *


* The Initial Developer of the Original Code is PSC.  The Original   *


* Code is Progress IDE code released to open source December 1, 2000.*


*                                                                    *


* The contents of this file are subject to the Possenet Public       *


* License Version 1.0 (the "License"); you may not use this file     *


* except in compliance with the License.  A copy of the License is   *


* available as of the date of this notice at                         *


* http://www.possenet.org/license.html                               *


*                                                                    *


* Software distributed under the License is distributed on an "AS IS"*


* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*


* should refer to the License for the specific language governing    *


* rights and limitations under the License.                          *


*                                                                    *


* Contributors:                                                      *


*                                                                    *


*********************************************************************/


/* t-a-eng.p - English language definitions for Admin module */





{ prores/t-define.i }





DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.





IF qbf-s < 0 THEN RETURN.


qbf-lang = "".





/*--------------------------------------------------------------------------*/


/*results.p,s-module.p*/


IF qbf-s = 1 THEN


  ASSIGN


    qbf-lang[ 1] = 'Q. '


    qbf-lang[ 2] = 'R. '


    qbf-lang[ 3] = 'L. /'


    qbf-lang[ 4] = 'D. '


    qbf-lang[ 5] = 'U. '


    qbf-lang[ 6] = 'A. '


    qbf-lang[ 7] = 'E. '


    qbf-lang[ 8] = 'F. FAST TRACK'


    qbf-lang[10] = ' ' /*DBNAME.qc*/


    qbf-lang[11] = ' .        "'


                 + ' "  "database".     ; '


    qbf-lang[12] = '     [' + KBLABEL("END-ERROR")


                 + ']    .'


    qbf-lang[13] = '    RESULTS.    '


    qbf-lang[14] = '   "~{1~}"'


    qbf-lang[15] = '-,,'


    qbf-lang[16] = '    "database".'


    qbf-lang[17] = '     DB   (logical) '


                 + '    "QBF$".'


    qbf-lang[18] = ''


    qbf-lang[19] = '**  RESULTS  **^^  ~{1~}, '


                 + '  ~{2~}.db    ~{2~}.qc  .  ~{3~}.qc'


                 + '   PROPATH,      '


                 + '~{3~}.db. ,   PROPATH  /'


                 + '  ~{3~}.db  .qc.'


    /* 24,26,30,32 available if necessary */


    qbf-lang[21] = '                  '


                 + 'PROGRESS'


    qbf-lang[22] = '         RESULTS.    RESULTS    '


                 + ' ,'


    qbf-lang[23] = '            ,  .'


    qbf-lang[24] = '     ,   ' 


    qbf-lang[25] = ' .'


    qbf-lang[27] = '        '


    qbf-lang[28] = '  "database",  RESULTS  ' 


    qbf-lang[29] = '      .'


    qbf-lang[31] = ' RESULTS      .'.








/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


/*a-user.p*/


IF qbf-s = 2 THEN


  /* format x(72) for 1,2,9-14,19-22 */


  ASSIGN


    qbf-lang[ 1] = '      (Include)  '


    qbf-lang[ 2] = '   ""    .'


    qbf-lang[ 3] = '    Include:' /*format x(24)*/





    qbf-lang[ 8] = '   '





    qbf-lang[ 9] = '     .   '


                 + '  '


    qbf-lang[10] = '         '


                 + ' login.p'


    qbf-lang[11] = '    "DLC".     '


                 + ' '


    qbf-lang[12] = '   "signon="    DBNAME.qc.'


    qbf-lang[13] = '        '


    qbf-lang[14] = '  .'


    qbf-lang[15] = '     :' /*format x(24)*/


    qbf-lang[16] = '      :' /*format x(24)*/


    qbf-lang[17] = ' :'





    qbf-lang[18] = 'PROGRESS  :'


    qbf-lang[19] = '       "" '


                 + ' .'





    qbf-lang[20] = ',         '


    qbf-lang[21] = '.         '


    qbf-lang[22] = '    "  - ".'


    qbf-lang[23] = ':'


    qbf-lang[24] = ':'.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


/*a-load.p:*/


IF qbf-s = 3 THEN


  ASSIGN


    /* menu strip for d-main.p,l-main.p,r-main.p */


    qbf-lang[ 1] = '.,  ~{1~}.'


    qbf-lang[ 2] = '.,   ~{1~}.'


    qbf-lang[ 3] = '.,   ~{1~}.'


    qbf-lang[ 4] = '.,   .'


    qbf-lang[ 5] = '., ,      ~{1~}.'


    qbf-lang[ 6] = ',        WHERE.'


    qbf-lang[ 7] = '.,     .'


    qbf-lang[ 8] = '.,   ~{1~}.'


    qbf-lang[ 9] = '.,    .'


    qbf-lang[10] = '.,  .'


    qbf-lang[11] = '.,      .'


    qbf-lang[12] = ',.'


    qbf-lang[13] = '' /* terminator */


    qbf-lang[14] = ',,'





    qbf-lang[15] = '    ...'





    /* system values for CONTINUE Must be <= 12 characters */


    qbf-lang[18] = '  ' /* for error dialog box */


    qbf-lang[19] = ' (928)' /* this name of this language */


    /* word "of" for "xxx of yyy" on scrolling lists */


    qbf-lang[20] = ''


    /* standard product name */


    qbf-lang[22] = 'PROGRESS RESULTS'


    /* system values for descriptions of calc fields */


    qbf-lang[23] = ', ,  ,,  ,'


                 + '  ,  , , '


    /* system values for YES and NO.  Must be <= 8 characters each */


    qbf-lang[24] = '    ,    ' /* for yes/no dialog box */





    qbf-lang[25] = '     .  '


                 + '    ; '





    qbf-lang[26] = '*  -   *^^    '


                 + '<~{1~}>      .qc  <~{2~}>.   '


                 + '        '


                 + '    " ".'





    qbf-lang[27] = '*  -  "Database" *^^  "database" '


                 + '     :'





    qbf-lang[32] = '*  -    DB   *^^   '


                 + '   .  '


                 + '    " " '


                 + '    .'.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


/* a-main.p */


IF qbf-s = 4 THEN


  ASSIGN


    qbf-lang[ 1] = " A.  "


    qbf-lang[ 2] = " F.    "


    qbf-lang[ 3] = " R.   "





    qbf-lang[ 4] = " C.   "


    qbf-lang[ 5] = " H.    "


    qbf-lang[ 6] = " M.  "


    qbf-lang[ 7] = " Q.  "


    qbf-lang[ 8] = " S.  /"





    qbf-lang[11] = " G. "


    qbf-lang[12] = " P.  "


    qbf-lang[13] = " T.   "





    qbf-lang[14] = " B.  ()"


    qbf-lang[15] = " D.  "


    qbf-lang[16] = " E.   "


    qbf-lang[17] = " L.    "


    qbf-lang[18] = " U.   "





    qbf-lang[21] = '   [' + KBLABEL("END-ERROR")


                 + ']     .'


    /* these next four have a length limit of 20 including colon */


    qbf-lang[22] = ':'


    qbf-lang[23] = ':'


    qbf-lang[24] = ':'


    qbf-lang[25] = ':'





    qbf-lang[26] = ' '


    qbf-lang[27] = ''


    qbf-lang[28] = '      '


                 + '  .'


    qbf-lang[29] = '     '


/* QUIT and RETURN are the PROGRESS keywords and cannot be translated */


    qbf-lang[30] = '    ""    , '


                 + '      ; "Quit"  "Return"'


    qbf-lang[31] = '     '  


                 + ' '


    qbf-lang[32] = '        '


                 + ' .'.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


IF qbf-s = 5 THEN


  ASSIGN


/*a-perm.p, 1..7 also used by a-form.p and a-print.p*/


    qbf-lang[ 1] = ''


    qbf-lang[ 2] = ' *                         -     .'


    qbf-lang[ 3] = ' <>,<>,.  -      .'


    qbf-lang[ 4] = ' !<>,!<>,*   -       '


                 + '.'


    qbf-lang[ 5] = ' acct*                     -     "acct" '


                 + ' .'


    qbf-lang[ 6] = '      (Login ID),   '


                 + '.'


    qbf-lang[ 7] = '      "".   '


                 + '.'


                   /* from 8 thru 13, format x(30) */


    qbf-lang[ 8] = '    '


    qbf-lang[ 9] = '    '


    qbf-lang[10] = '    .'


    qbf-lang[11] = '     '


    qbf-lang[12] = '     '


    qbf-lang[13] = '    .'


    qbf-lang[14] = ' [' + KBLABEL("END-ERROR")


                 + ']    .'


    qbf-lang[15] = ' [' + KBLABEL("GO") + ']  , ['


                 + KBLABEL("END-ERROR") + ']  .'


    qbf-lang[16] = '            !'


/*a-print.p:*/     /*21 thru 26 must be format x(16) and right-justified */


    qbf-lang[21] = '(Reset)'


    qbf-lang[22] = '                '


    qbf-lang[23] = '        '


    qbf-lang[24] = '    '  


    qbf-lang[25] = '          '


    qbf-lang[26] = '  '.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


IF qbf-s = 6 THEN


  ASSIGN


/*a-write.p:*/


    qbf-lang[ 1] = '  '


    qbf-lang[ 2] = '   '


    qbf-lang[ 3] = '  '


    qbf-lang[ 4] = '    '


    qbf-lang[ 5] = '    '


    qbf-lang[ 6] = '      '


    qbf-lang[ 7] = '     '


    qbf-lang[ 8] = '     '


    qbf-lang[ 9] = '     '





/* a-color.p*/


                 /* 12345678901234567890123456789012 */


    qbf-lang[11] = '       :' /* must be 32 */


                 /* 1234567890123456789012345 */


    qbf-lang[12] = ':          :' /* must be 25 */


    qbf-lang[13] = '            :'


    qbf-lang[14] = '.: :'


    qbf-lang[15] = '            :'


    qbf-lang[16] = ' : :'


    qbf-lang[17] = '            :'





/*a-field.p*/    /*"----- ----- ----- ----- ----"*/


    qbf-lang[30] = '  .  '


    qbf-lang[31] = '     1  9999.'


    qbf-lang[32] = '        '


                 + ' ; '.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


IF qbf-s = 8 THEN


/*a-label.p*/


  ASSIGN            /* 1..8 use format x(78) */


                    /* 1 and 8 are available for more explanation, in */


                    /*   case the translation won't fit in 2 thru 7.  */


    qbf-lang[ 1] = '         '


                 + '. '


    qbf-lang[ 2] = '   CAN-DO     '


                 + '   ("*" '


    qbf-lang[ 3] = '     , "."  '


                 + '  ).'


    qbf-lang[ 4] = '       '


                 + ' .'


    qbf-lang[ 5] = '  ''       '


                 + ',  '


    qbf-lang[ 6] = ' ,   ..    , '


                 + '  "-- "'


    qbf-lang[ 7] = '.'


                  /* each entry in list must be <= 5 characters long */


                  /* but may be any portion of address that is applicable */


                  /* in the target country */


    qbf-lang[ 9] = ',,1,2,3,..,,-,,'


    qbf-lang[10] = '     / <>'


    qbf-lang[11] = '        <>'


    qbf-lang[12] = '     <>    (.. )'


    qbf-lang[13] = '    <>    (.. .)'


    qbf-lang[14] = '    <>    ()'


    qbf-lang[15] = '       <..>'


    qbf-lang[16] = '     <>'


    qbf-lang[17] = '    <..- >   '


    qbf-lang[18] = '      <>'


    qbf-lang[19] = '      <>'





/*a-join.p*/


    qbf-lang[23] = '   "-"     .'


    qbf-lang[24] = '        .'


    qbf-lang[25] = ' ' /* 25 and 26 are automatically */


    qbf-lang[26] = ' '          /*   right-justified           */


    qbf-lang[27] = '   WHERE  OF : (      )'


    qbf-lang[28] = ' [' + KBLABEL("END-ERROR") + ']    .'


    qbf-lang[30] = '      WHERE  OF.'


    qbf-lang[31] = '           .'


    qbf-lang[32] = ',        .'.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


/* a-form.p */


IF qbf-s = 9 THEN


  ASSIGN           /* 1..6 format x(45) */


    qbf-lang[ 1] = ' A.    '


    qbf-lang[ 2] = ' C.      '


    qbf-lang[ 3] = ' G.    '


    qbf-lang[ 4] = ' W.     '


    qbf-lang[ 5] = ' P.  '


    qbf-lang[ 6] = ' D.    '


    qbf-lang[ 7] = '  :' /* format x(10) */


    qbf-lang[ 8] = ' :' /* format x(10) */


                 /* cannot changed width of 9..16 from defined below */


    qbf-lang[ 9] = '      DB' /* right-justify 9..14 */


    qbf-lang[10] = '            '


    qbf-lang[11] = '      '


    qbf-lang[12] = '  '


    qbf-lang[13] = '  Frame  4GL'


    qbf-lang[14] = '              '


    qbf-lang[15] = '( .p)' /* left-justify 15 and 16 */


    qbf-lang[16] = '( extension)'


    qbf-lang[18] = 'H   ~{1~} .   RESULTS  '


                 + '     ,     '


                 + '   24x80.       '


                 + '  ; '


    qbf-lang[19] = '     ''  .'


    qbf-lang[20] = '           .f  '


                 + '   .'


    qbf-lang[21] = '   "Frame"    4GL   '


                 + ' .   .'


    qbf-lang[22] = '   '


    qbf-lang[23] = ' [' + KBLABEL("END-ERROR") + ']    '


    qbf-lang[24] = '      ...'


    qbf-lang[25] = '     .   '


                 + ',  "compile"   ,  " '


                 + '" .   "Compile" ; '


    qbf-lang[26] = '      "~{1~}".'


                 + '   ; '


    qbf-lang[27] = '      "~{1~}".'


                 + '       ''  ; '


    qbf-lang[28] = '    '


    qbf-lang[29] = '** To   - "~{1~}" . **'


    qbf-lang[30] = '   ...'


    qbf-lang[31] = '       .'


    qbf-lang[32] = '      ''  .^^  '


                 + '  ,   ""    "RECIDs", '


                 + '     (unique index)   .'.





/*--------------------------------------------------------------------------*/





ELSE





/*--------------------------------------------------------------------------*/


/* a-print.p */


IF qbf-s = 10 THEN


  ASSIGN           /* 1..6 format x(45) */


    qbf-lang[ 1] = ' A.     '


    qbf-lang[ 2] = ' C.     '


    qbf-lang[ 3] = ' G.     '


    qbf-lang[ 4] = ' S.   '


    qbf-lang[ 5] = ' P.   '


    qbf-lang[ 6] = ' D.     '


    qbf-lang[ 7] = ' : ' /* format x(10) */


    qbf-lang[ 8] = ' :' /* format x(10) */


    qbf-lang[ 9] = '     1  255.'


    qbf-lang[10] = 'O     term, thru, to, view, file, page  prog'


    qbf-lang[11] = '      .'


    qbf-lang[12] = '    "term"      TERMINAL.'


    qbf-lang[13] = '        PROPATH.'


                  /*17 thru 20 must be format x(16) and right-justified */


    qbf-lang[17] = ' '


    qbf-lang[18] = ' '


    qbf-lang[19] = '    '


    qbf-lang[20] = '           '


    qbf-lang[21] = ' '


    qbf-lang[22] = 'TERMINAL,  OUTPUT TO TERMINAL PAGED'


    qbf-lang[23] = 'TO  ,  OUTPUT TO PRINTER'


    qbf-lang[24] = 'THROUGH  spooler   UNIX  OS/2'


    qbf-lang[25] = '    ,      '


    qbf-lang[26] = '        '


    qbf-lang[27] = '   /  (prev-page  next-page)'


    qbf-lang[28] = '  4GL   /   '


    qbf-lang[30] = ' [' + KBLABEL("END-ERROR") + ']    '


    qbf-lang[31] = '       !'


    qbf-lang[32] = '   '.





/*--------------------------------------------------------------------------*/





RETURN.


